# used for easy branding
%define distro			mageia

%define branch			8
%define branch_major		4
%define branch_minor		0
%define rel			1
%define branch_tag		%(perl -e 'printf "%%02d%%02d", split(/\\./,shift)' %{branch})
%define snapshot		%nil
%define nof_arches		noarch
%define biarches		x86_64

# Define libraries major versions
%define libcc_major		0
%define libgcc_major		1
%define libstdcxx_major		6
%define libstdcxx_micro		25
%define libgfortran_major	5
%define libobjc_major		4
%define libgnat_major		8
%define libffi_major		4
%define libssp_major		0
%define libgomp_major		1
%define libquadmath_major	0
%define libitm_major		1
%define libasan_major		5
%define libatomic_major		1
%define libatomic_minor		2
%define liblsan_major		0
%define libtsan_major		0
%define libubsan_major		1
%define libvtv_major		0
%define libmpx_major		2
%define libmpx_micro		1

# Disable -Werror because there's a format string warning in gcc/cp/parser.c 
# around line 2300 that a comment says is intentional :( 
%define Werror_cflags %nil

# Define if building a cross compiler
# FIXME: assume user does not define both cross and cross_bootstrap variables
%define build_cross		0
%define build_cross_bootstrap	0
%{expand: %{?cross:		%%global build_cross 1}}
%{expand: %{?cross_bootstrap:	%%global build_cross_bootstrap 1}}

# System compiler in Mageia
%define system_compiler		1

%define target_cpu		%{_target_cpu}
%if %{build_cross}
%define system_compiler		0
%define target_cpu		%{cross}
%endif
%if %{build_cross_bootstrap}
%define build_cross		1
%define system_compiler		0
%define target_cpu		%{cross_bootstrap}
%endif
%if %{system_compiler}
%define alternative_priority	30%{branch_tag}
%define cross_prefix		%{nil}
%define cross_program_prefix	%{nil}
%define package_suffix		%{nil}
%define program_prefix		%{nil}
%define program_suffix		%{nil}
%define program_long_suffix     -%{version}
%else
%if %{build_cross}
%define alternative_priority	10%{branch_tag}
%define cross_prefix		cross-%{target_cpu}-
%define cross_program_prefix	%{target_cpu}-%{_real_vendor}-linux%{gnuext}-
%define package_suffix		%{nil}
%define program_prefix		%{cross_program_prefix}
%define program_suffix		%{nil}
%define program_long_suffix	-%{version}
%else
%define alternative_priority	20%{branch_tag}
%define cross_prefix		%{nil}
%define cross_program_prefix	%{nil}
%define package_suffix		%{branch}
%define program_prefix		%{nil}
%define program_suffix		%{branch}
%define program_long_suffix	%{branch}
%endif
%endif
%define _alternativesdir	/etc/alternatives
%if "%{package_suffix}" == "%{nil}"
%define _package_suffix		%{nil}
%else
%define _package_suffix		-%{package_suffix}
%endif

%if "%snapshot" != ""
%define source_package		gcc-%{version}-RC-%{snapshot}
%define source_dir		gcc-%{version}-RC-%{snapshot}
%else
%define source_package		gcc-%{version}
%define source_dir		gcc-%{version}
%endif

# Define GCC target platform, and arch we built for
%if %{build_cross}
%define biarches		noarch
%define arch			%{target_cpu}
%define gcc_target_platform	%{target_cpu}-%{_real_vendor}-linux%{gnuext}
%define target_prefix		%{_prefix}/%{gcc_target_platform}
%define target_libdir		%{target_prefix}/%{target_lib}
%define target_slibdir		%{target_prefix}/%{target_lib}
%define target_slibdir32	%{target_prefix}/lib
%else
%define arch			%(echo %{_target_cpu}|sed -e "s/\\(i.86\\|athlon\\)/i386/" -e "s/amd64/x86_64/")
%define gcc_target_platform	%{_target_platform}
%define target_prefix		%{_prefix}
%define target_libdir		%{_libdir}
%define target_slibdir		/%{_lib}
%define target_slibdir32	/lib
%endif
%define isarch()		%(case " %* " in (*" %{arch} "*) echo 1;; (*) echo 0;; esac)
%define gcc_libdir		%{_prefix}/lib/gcc

%if %{build_cross}
%if %isarch %arm
%define gnuext			-gnueabi
%else
%define gnuext			-gnu
%endif
%endif

%if %isarch x86_64 aarch64
%define target_lib		lib64
%else
%define target_lib		lib
%endif

%if %isarch x86_64
%define multilib_32_arch	i586
%endif
%if %isarch %{biarches}
%define gcc32_target_platform	%{multilib_32_arch}-%{distro}-%{_target_os}%{?_gnu}
%endif

# We now have versioned libstdcxx_includedir, that is c++/<VERSION>/
%define libstdcxx_includedir	%{target_prefix}/include/c++/%{version}

%define build_minimal		0
%define build_monolithic	0
%define build_doc		1
%define build_pdf_doc		0
%define build_libstdcxx_docs	1
%define build_check		0
%define build_ada		1
%define build_cxx		1
%define build_libstdcxx		%{build_cxx}
%define build_fortran		1
%if %isarch %arm aarch64
%define build_quadmath		0
%else
%define build_quadmath		1
%endif
%define build_objc		1
%define build_objc_gc		0
%define build_objcp		1
%define build_libffi		0
%define build_libgomp		1
%define build_debug		0
%define build_stdcxxheaders	1
%define build_libitm		1
%define build_libasan		1
%define build_libatomic		1
%define build_libubsan		1
# only i?86 and x86_64 are supported, see libvtv/configure.tgt
%ifarch %{ix86} x86_64
%define build_libvtv		0
%else
%define build_libvtv		0
%endif
%if %isarch x86_64 aarch64
%define build_liblsan		1
%define build_libtsan		1
%else
%define build_liblsan		0
%define build_libtsan		0
%endif
%ifarch %{ix86} x86_64
%define build_libmpx		1
%else
%define build_libmpx		0
%endif
# use SSP support from glibc
%define use_ssp_glibc		1
%define build_libssp		0
%if !%{system_compiler}
%define build_objc		0
%define build_objc_gc		0
%define build_objcp		0
%define build_ada		0
%define build_libffi		0
%define build_libgomp		0
%endif
%define build_isl		1

# Define C library to use
%define libc glibc
%define libc_shared 1
%if !%{build_cross_bootstrap}
# Make sure pthread.h doesn't contain __thread keyword
%define libc_version 		2.2.5-14
%if %{use_ssp_glibc}
# Make sure glibc supports stack protector
%define libc_version 		2.4-1
%endif
%endif

# Allow --with[out] <feature> at rpm command line build
%{expand: %{?_without_PDF:	%%global build_pdf_doc 0}}
%{expand: %{?_without_DEBUG:	%%global build_debug 0}}
%{expand: %{?_without_check:	%%global build_check 0}}
%{expand: %{?_without_CHECK:	%%global build_check 0}}
%{expand: %{?_without_MINIMAL:	%%global build_minimal 0}}
%{expand: %{?_with_PDF:		%%global build_pdf_doc 1}}
%{expand: %{?_with_DEBUG:	%%global build_debug 1}}
%{expand: %{?_with_CHECK:	%%global build_check 1}}
%{expand: %{?_with_MINIMAL:	%%global build_minimal 1}}

# Allow --without <front-end> at rpm command line build
%{expand: %{?_with_CXX:		%%global build_cxx 1}}
%{expand: %{?_with_ADA:		%%global build_ada 1}}
%{expand: %{?_with_FORTRAN:	%%global build_fortran 1}}
%{expand: %{?_with_OBJC:	%%global build_objc 1}}
%{expand: %{?_with_OBJCXX:	%%global build_objcp 1}}

# Allow --with <front-end> at rpm command line build
%{expand: %{?_without_CXX:	%%global build_cxx 0}}
%{expand: %{?_without_ADA:	%%global build_ada 0}}
%{expand: %{?_without_FORTRAN:	%%global build_fortran 0}}
%{expand: %{?_without_OBJC:	%%global build_objc 0}}
%{expand: %{?_without_OBJCXX:	%%global build_objcp 0}}

# A minimal build overrides all other options
%if %{build_cross_bootstrap}
%define build_minimal		1
%define libc_shared		0
%endif
%if %{build_minimal}
%define build_doc		0
%define build_pdf_doc		0
%define build_libstdcxx_docs	0
%define build_check		0
%define build_ada		0
%define build_cxx		0
%define build_fortran		0
%define build_quadmath		0
%define build_objc		0
%define build_objc_gc		0
%define build_objcp		0
%define build_debug		0
%define build_libffi		0
%define build_libitm		0
%define build_libasan		0
%define build_libatomic		0
%define build_liblsan		0
%define build_libtsan		0
%define build_libubsan		0
%define build_libmpx		0
%endif
%if %{build_cross}
%define build_monolithic	1
%define build_doc		0
%define build_pdf_doc		0
%define build_libstdcxx_docs	0
# Unsupported front-ends when cross-compiling for now
%define build_check		0
%define build_ada		0
%define build_libffi		0
%endif

# Define library packages names
%define libgcc_name_orig	%{cross_prefix}libgcc
%define libgcc_name		%{libgcc_name_orig}%{libgcc_major}
%define libstdcxx_name_orig	%{cross_prefix}libstdc++
%define libstdcxx_name		%{libstdcxx_name_orig}%{libstdcxx_major}
%define libgfortran_name_orig	%{cross_prefix}libgfortran
%define libgfortran_name	%{libgfortran_name_orig}%{libgfortran_major}
%define libobjc_name_orig	%{cross_prefix}libobjc
%define libobjc_name		%{libobjc_name_orig}%{libobjc_major}
%define libgnat_name_orig	%{cross_prefix}libgnat
%define libgnat_name		%{libgnat_name_orig}%{libgnat_major}
%define libffi_name_orig	%{cross_prefix}libffi
%define libffi_name		%{libffi_name_orig}%{libffi_major}
%define libssp_name_orig	%{cross_prefix}libssp
%define libssp_name		%{libssp_name_orig}%{libssp_major}
%define libgomp_name_orig	%{cross_prefix}libgomp
%define libgomp_name		%{libgomp_name_orig}%{libgomp_major}
%define libquadmath_name_orig	%{cross_prefix}libquadmath
%define libquadmath_name	%{libquadmath_name_orig}%{libquadmath_major}
%define libitm_name_orig	%{cross_prefix}libitm
%define libitm_name		%{libitm_name_orig}%{libitm_major}
%define libasan_name_orig	%{cross_prefix}libasan
%define libasan_name		%{libasan_name_orig}%{libasan_major}
%define libatomic_name_orig	%{cross_prefix}libatomic
%define libatomic_name		%{libatomic_name_orig}%{libatomic_major}
%define liblsan_name_orig	%{cross_prefix}liblsan
%define liblsan_name		%{liblsan_name_orig}%{liblsan_major}
%define libtsan_name_orig	%{cross_prefix}libtsan
%define libtsan_name		%{libtsan_name_orig}%{libtsan_major}
%define libubsan_name_orig	%{cross_prefix}libubsan
%define libubsan_name		%{libubsan_name_orig}%{libubsan_major}
%define libvtv_name_orig	%{cross_prefix}libvtv
%define libvtv_name		%{libvtv_name_orig}%{libvtv_major}
%define libmpx_name_orig	%{cross_prefix}libmpx
%define libmpx_name		%{libmpx_name_orig}%{libmpx_major}

# Extract Mageia name and version
%define mga_distro_version_file	/etc/release
%define mga_distro_version	%(perl -ne '/^([.\\w\\s]+) \\(.+\\).+/ and print $1' < %{mga_distro_version_file})

Summary:	GNU Compiler Collection
Name:		%{cross_prefix}gcc%{package_suffix}
Version:	%{branch}.%{branch_major}.%{branch_minor}
%if "%snapshot" != ""
Release:	%mkrel 0.RC.%{rel}
%else
Release:	%mkrel %{rel}
%endif
License:	GPLv3+
Group:		Development/C

# Main source:	
URL:		https://gcc.gnu.org/
%if "%snapshot" != ""
Source0:	https://gcc.gnu.org/pub/gcc/snapshots/%{version}-RC-%{snapshot}/%{source_package}.tar.xz
%else
Source0:	https://ftpmirror.gnu.org/gcc/%{source_package}/%{source_package}.tar.xz
%endif

# Patches
# upstream gcc-8 branch, numbered from 1
Patch001:	0001-lto-also-copy-.note.gnu.property-section.patch

# upstream master branch, numbered from 101

# Mageia patches, numbered from 201
# build 32 bits code when running through linux32
Patch201:	gcc-8.3-linux32.patch
# slibdir is either /lib or /lib64
Patch202:	gcc-8.3-pass-slibdir.patch
# pass libdir around
Patch203:	gcc-8.3-multi-do-libdir.patch

# Fedora patches, numbered from 501

# Want updated alternatives priorities
%if %{build_cross}
Conflicts:	gcc-cpp < 3.2.2-4
%endif
# TEMP FORCE NEW binutils
%define binutils_version 1:2.33.1-1

# libmudflap got dropped in upstream 4.9
Obsoletes:	libmudflap0
Obsoletes:	libmudflap-devel
# libcilkrts got dropped in upstream 8.0
Obsoletes:	libcilkrts5
Obsoletes:	libcilkrts-devel

Requires:	%{cross_prefix}binutils >= %{binutils_version}
BuildRequires:	%{cross_prefix}binutils >= %{binutils_version}
# c++ is mandatory to build gcc
BuildRequires:	gcc-c++ >= 8.3.0-1
# Make sure gdb will understand DW_FORM_strp
Conflicts:	gdb < 5.1.1
BuildRequires:	zlib-devel
BuildRequires:	chrpath

BuildRequires:  gcc >= 8.3.0-1

%if %{build_ada}
# Ada requires Ada to build
BuildRequires:	%{name}-gnat >= 8.3.0-1
%endif
# isl is used for Graphite support (optimizations)
# see http://gcc.gnu.org/wiki/Graphite
%if %{build_isl}
BuildRequires:	isl-devel >= 0.14
%endif
#needed for lto support
BuildRequires:	elfutils-devel
Requires:	%{name}-cpp = %{version}-%{release}
# FIXME: We need a libgcc with 3.4 symbols
%if %{libc_shared} && !%{build_monolithic}
Requires:	%{libgcc_name_orig} >= 3.3.2-5
%endif
Requires(post): update-alternatives
Requires(postun): update-alternatives
BuildRequires:	gettext
BuildRequires:	flex
BuildRequires:	bison
BuildRequires:	texinfo >= 4.1
BuildRequires:	texinfo-tex
# XXX: Needs a GNU awk recent enough to correctly generate options.h
BuildRequires:	gawk >= 3.1.4
%if "%{?libc_version:%{libc_version}}" != ""
Requires:	%{cross_prefix}%{libc}-devel >= %{libc_version}
BuildRequires:	%{cross_prefix}%{libc}-devel >= %{libc_version}
%endif
%if %{build_check}
BuildRequires:	%{cross_prefix}glibc-static-devel
BuildRequires:	autogen
%endif
%if %{system_compiler}
Obsoletes:	gcc%{branch}
Provides:	gcc%{branch} = %{version}-%{release}
# see later warning about libgcc_so & ld script
# rpm has not way to find that ld script is ld script
%if !%build_cross
%if %isarch %{arm} %{ix86} x86_64
Provides:	devel(libgcc_s)
%endif
%if %isarch x86_64 aarch64
Provides:	devel(libgcc_s(64bit))
%endif
%endif
%else
Conflicts:	%{cross_prefix}gcc%{branch} < %{version}-%{release}
%endif
%if %{build_pdf_doc}
BuildRequires:	tetex
BuildRequires:	dvips
BuildRequires:	tetex-latex
%endif
%if %{build_libstdcxx_docs}
BuildRequires: doxygen
BuildRequires: graphviz
%endif
%if %{build_check}
BuildRequires:	dejagnu
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif
BuildRequires:	libgmp-devel
BuildRequires:	pkgconfig(mpfr)
BuildRequires:	libmpc-devel
# gcc-java is gone
Obsoletes:	gcc-java
Obsoletes:	gcj-tools
Obsoletes:	%{_lib}gcj16
Obsoletes:	%{_lib}gcj_bc1
Obsoletes:	%{_lib}gcj-devel
Obsoletes:	%{_lib}gcj-static-devel
Obsoletes:	libgcj16-base
Obsoletes:	libgcj16-src
# cilk is gone
Obsoletes:	libcilkrts5
Obsoletes:	libcilkrts-devel
# vtv is gone
Obsoletes:	libvtv0
Obsoletes:	libvtv-devel

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.
This package is required for all other GCC compilers, namely C++,
Fortran 95, Objective C, Java and Ada 95.

%package -n %{libgcc_name}
Summary:	GNU C library
Group:		System/Libraries
Provides:	%{libgcc_name_orig} = %{version}-%{release}
Obsoletes:	%{libgcc_name_orig}%{branch}
Provides:	%{libgcc_name_orig}%{branch} = %{version}-%{release}
Obsoletes:	%{libgcc_name_orig}3.0
Provides:	%{libgcc_name_orig}3.0 = %{version}-%{release}
Provides:	%{libgcc_name_orig}3.2 = %{version}-%{release}
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libgcc_name}
The %{libgcc_name} package contains GCC shared libraries for gcc %{branch}

####################################################################
# C++ Compiler

%package c++
Summary:	C++ support for gcc
Group:		Development/C++
%if %{system_compiler}
Obsoletes:	gcc%{branch}-c++
Provides:	gcc%{branch}-c++ = %{version}-%{release}
%else
Conflicts:	%{cross_prefix}gcc%{branch}-c++ < %{version}-%{release}
%endif
Requires:	%{name} = %{version}-%{release}
%if %{system_compiler}
# some day, rpm will be smart enough: #if (#{system_compiler} || #{build_cross}) && !#{build_monolithic}
%if %{libc_shared}
Requires:	%{libstdcxx_name} = %{version}
%endif
Requires:	%{libstdcxx_name_orig}-devel = %{version}
%endif

%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif
Requires(post): update-alternatives
Requires(postun): update-alternatives

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

####################################################################
# gcc Plugins
%package -n %{name}-plugins
Summary:	Headers to build gcc plugins
Group:		Development/C
%description -n %{name}-plugins
This package contains the headers needed to build gcc plugins.

####################################################################
# C++ Libraries

%package -n %{libstdcxx_name}
Summary:	GNU C++ library
Group:		System/Libraries
Provides:	%{libstdcxx_name_orig} = %{version}-%{release}
%if "%{branch}" == "3.3"
# By default, the libstdc++ from gcc3.3 is ABI compatible with the one
# from gcc3.2. Just tell other packages about it if they relied on that.
Provides:	%{libstdcxx_name_orig}3.2 = %{version}-%{release}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libstdcxx_name}
This package contains the GCC Standard C++ Library v3, an ongoing
project to implement the ISO/IEC 14882:1998 Standard C++ library.

%package -n %{libstdcxx_name_orig}-devel
Summary:	Header files and libraries for C++ development
Group:		Development/C++
%if %{libc_shared}
Requires:	%{libstdcxx_name} = %{version}-%{release}
%endif
Provides:	%{libstdcxx_name_orig}6-devel
Obsoletes:	%{libstdcxx_name_orig}6-devel
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libstdcxx_name_orig}-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development.

%package -n %{libstdcxx_name_orig}-static-devel
Summary:	Static libraries for C++ development
Group:		Development/C++
Requires:	%{libstdcxx_name_orig}-devel = %{version}-%{release}
Provides:	%{libstdcxx_name_orig}6-static-devel
Obsoletes:	%{libstdcxx_name_orig}6-static-devel
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libstdcxx_name_orig}-static-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the static libraries needed for C++ development.

####################################################################
# Objective C Compiler

%package objc
Summary:	Objective C support for gcc
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-objc
Provides:	gcc%{branch}-objc = %{version}-%{release}
%endif
Requires:	%{name} = %{version}-%{release}
%if %{libc_shared} && !%{build_monolithic}
Requires:	%{libobjc_name} = %{version}-%{release}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is an object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
Objective C object library.

####################################################################
# Objective C++ Compiler

%package objc++
Summary:	Objective C++ support for gcc
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-objc++
Provides:	gcc%{branch}-objc++ = %{version}-%{release}
%endif
Requires:	%{name}-objc = %{version}-%{release}
Requires:	%{name}-c++ = %{version}-%{release}
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description objc++
This package adds Objective C++ support to the GNU C++ compiler.

####################################################################
# Objective C Libraries

%package -n %{libobjc_name}
Summary:	Objective C runtime libraries
Group:		System/Libraries
Obsoletes:	%{libobjc_name_orig}3.0, %{libobjc_name_orig}3.1
Provides:	%{libobjc_name_orig} = %{version}-%{release}
Provides:	%{libobjc_name_orig}3.0 = %{version}-%{release}
Provides:	%{libobjc_name_orig}3.1 = %{version}-%{release}
%if !%{system_compiler}
Conflicts:	%{name}-objc < %{branch}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libobjc_name}
Runtime libraries for the GNU Objective C Compiler.

####################################################################
# Fortran 95 Compiler

%package gfortran
Summary:	Fortran 95 support for gcc
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-gfortran
Provides:	gcc%{branch}-gfortran = %{version}-%{release}
%endif
Requires:	%{name} = %{version}-%{release}
%if %{build_quadmath}
Requires:	quadmath-devel = %{version}-%{release}
%endif
%if %{libc_shared} && !%{build_monolithic}
Requires:	%{libgfortran_name} = %{version}-%{release}
%endif
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description gfortran
This package adds support for compiling Fortran 95 programs with the GNU
compiler.

####################################################################
# Fortran 95 Libraries

%package -n %{libgfortran_name}
Summary:	Fortran 95 runtime libraries
Group:		System/Libraries
%if %{build_quadmath}
Requires:	%{libquadmath_name} = %{version}-%{release}
%endif
Provides:	%{libgfortran_name_orig} = %{version}
Obsoletes:	%{libgfortran_name_orig}%{branch}
Provides:	%{libgfortran_name_orig}%{branch} = %{version}-%{release}
# upgrade from mga6
Obsoletes:	libgfortran3
%if %{build_cross}
AutoReq:	false
AutoProv:	false
%endif

%description -n %{libgfortran_name}
This package contains Fortran 95 shared library which is needed to run
Fortran 95 dynamically linked programs.

####################################################################
# Quadmath Libraries

%if %{build_quadmath}
%package -n %{libquadmath_name}
Summary:	GCC __float128 shared support library
Group:		System/Libraries
Provides:	%{libquadmath_name_orig} = %{version}-%{release}

%description -n %{libquadmath_name}
This package contains GCC shared support library which is needed
for __float128 math support and for Fortran REAL*16 support.

%package -n %{libquadmath_name_orig}-devel
Summary:	GCC __float128 support
Group:		Development/C
Provides:	quadmath-devel = %{version}-%{release}

%description -n %{libquadmath_name_orig}-devel
This package contains support for building Fortran programs using
REAL*16 and programs using __float128 math.
%endif

####################################################################
# ITM Libraries

%if %{build_libitm}
%package -n %{libitm_name}
Summary:	The GNU Transactional Memory library
Group:		System/Libraries
Provides:	%{libitm_name_orig} = %{version}-%{release}

%description -n %{libitm_name}
This package contains the GNU Transactional Memory library
which is a GCC transactional memory support runtime library.

%package -n %{libitm_name_orig}-devel
Summary:	The GNU Transactional Memory library devel files
Group:		Development/C
Provides:	libitm-devel = %{version}-%{release}
Requires: 	%{libitm_name_orig} = %{version}-%{release}
Requires: 	gcc = %{version}-%{release}

%description -n %{libitm_name_orig}-devel
This package contains headers and support files for the
GNU Transactional Memory library.
%endif

####################################################################
# Address Sanitizer Libraries

%if %{build_libasan}
%package -n %{libasan_name}
Summary:	The Address Sanitizer runtime library
Group:		System/Libraries
Provides:	%{libasan_name_orig} = %{version}-%{release}
# upgrade from mga6
Obsoletes:	libasan2

%description -n %{libasan_name}
This package contains the Address Sanitizer library
which is used for -fsanitize=address instrumented programs.

%package -n %{libasan_name_orig}-devel
Summary:	The Address Sanitizer runtime library devel files
Group:		Development/C
Provides:	libasan-devel = %{version}-%{release}
Requires:	%{libasan_name} = %{version}-%{release}

%description -n %{libasan_name_orig}-devel
This package contains the devel files for Address Sanitizer library
which is used for -fsanitize=address instrumented programs.
%endif


####################################################################
# Leak Sanitizer Libraries

%if %{build_liblsan}
%package -n %{liblsan_name}
Summary:	The Leak Sanitizer runtime library
Group:		System/Libraries
Provides:	%{liblsan_name_orig} = %{version}-%{release}

%description -n %{liblsan_name}
This package contains the Leak Sanitizer library
which is used for -fsanitize=leak instrumented programs.

%package -n %{liblsan_name_orig}-devel
Summary:	The Leak Sanitizer runtime library devel files
Group:		Development/C
Provides:	liblsan-devel = %{version}-%{release}
Requires:	%{liblsan_name} = %{version}-%{release}

%description -n %{liblsan_name_orig}-devel
This package contains the devel files for Leak Sanitizer library
which is used for -fsanitize=leak instrumented programs.
%endif

####################################################################
# Thread Sanitizer Libraries

%if %{build_libtsan}
%package -n %{libtsan_name}
Summary:	The Thread Sanitizer runtime library
Group:		System/Libraries
Provides:	%{libtsan_name_orig} = %{version}-%{release}

%description -n %{libtsan_name}
This package contains the Thread Sanitizer library
which is used for -fsanitize=thread instrumented programs.

%package -n %{libtsan_name_orig}-devel
Summary:	The Thread Sanitizer runtime library devel files
Group:		Development/C
Provides:	libtsan-devel = %{version}-%{release}
Requires:	%{libtsan_name} = %{version}-%{release}

%description -n %{libtsan_name_orig}-devel
This package contains the devel files for Thread Sanitizer library
which is used for -fsanitize=thread instrumented programs.
%endif

####################################################################
# Undefined Behaviour Sanitizer Libraries

%if %{build_libubsan}
%package -n %{libubsan_name}
Summary:	The Undefined Behaviour Sanitizer runtime library
Group:		System/Libraries
Provides:	%{libubsan_name_orig} = %{version}-%{release}
# upgrade from mga6
Obsoletes:	libubsan0

%description -n %{libubsan_name}
This package contains the Undefined Behaviour Sanitizer library
which is used for -fsanitize=undefined instrumented programs.

%package -n %{libubsan_name_orig}-devel
Summary:	The Undefined Behaviour Sanitizer runtime library devel files
Group:		Development/C
Provides:	libubsan-devel = %{version}-%{release}
Requires:	%{libubsan_name} = %{version}-%{release}

%description -n %{libubsan_name_orig}-devel
This package contains the devel files for Undefined Behaviour Sanitizer
library which is used for -fsanitize=undefined instrumented programs.
%endif

####################################################################
# The GNU Atomic Libraries

%if %{build_libatomic}
%package -n %{libatomic_name}
Summary:	The GNU Atomic library
Group:		System/Libraries
Provides:	%{libatomic_name_orig} = %{version}-%{release}

%description -n %{libatomic_name}
This package contains the GNU Atomic library which is a GCC support
runtime library for atomic operations not supported by hardware.

%package -n %{libatomic_name_orig}-devel
Summary:	The Thread Sanitizer runtime library devel files
Group:		Development/C
Provides:	libtsan-devel = %{version}-%{release}
Requires:	%{libatomic_name} = %{version}-%{release}

%description -n %{libatomic_name_orig}-devel
This package contains the devel files for the GNU Atomic library
which is a GCC support runtime library for atomic operations not
supported by hardware.
%endif

####################################################################
# The Virtual Table Verification Libraries

%if %{build_libvtv}
%package -n %{libvtv_name}
Summary:	The Virtual Table Verification runtime libraries
Group:		System/Libraries
Provides:	%{libvtv_name_orig} = %{version}-%{release}

%description -n %{libvtv_name}
This package contains the Virtual Table Verification runtime libraries.

%package -n %{libvtv_name_orig}-devel
Summary:	The Virtual Table Verification runtime library devel files
Group:		Development/C
Provides:	libvtv-devel = %{version}-%{release}

%description -n %{libvtv_name_orig}-devel
This package contains the devel files for the Virtual Table Verification
runtime libraries.
%endif

####################################################################
# The MPX Libraries

%if %{build_libmpx}
%package -n %{libmpx_name}
Summary:	The Memory Protection Extensions runtime libraries
Group:		System/Libraries
Provides:	%{libmpx_name_orig} = %{version}-%{release}

%description -n %{libmpx_name}
This package contains the Memory Protection Extensions runtime libraries
which is used for -fcheck-pointer-bounds -mmpx instrumented programs.

%package -n %{libmpx_name_orig}-devel
Summary:	The Memory Protection Extensions development libraries
Group:		Development/C
Provides:	libmpx-devel = %{version}-%{release}

%description -n %{libmpx_name_orig}-devel
This package contains the devel files for the Memory Protection Extensions
runtime libraries.
%endif

####################################################################
# Ada 95 Compiler

%if %{build_ada}
%package gnat
Summary:	Ada 95 support for gcc
Group:		Development/Other
Requires:	%{libgnat_name} = %{version}-%{release}
%if %{system_compiler}
Obsoletes:	gcc%{branch}-gnat
Provides:	gcc%{branch}-gnat = %{version}-%{release}
%endif
Obsoletes:	%{cross_prefix}gnat
Provides:	%{cross_prefix}gnat = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description gnat
This package contains an Ada95 compiler and associated development
tools based on the GNU gcc technology. Ada95 is the object oriented
successor of the Ada83 language. To build this package from sources
you must have installed a binary version to bootstrap the compiler.

####################################################################
# Ada 95 Libraries

%package -n %{libgnat_name}
Summary:	Ada 95 runtime libraries
Group:		System/Libraries
Provides:	%{libgnat_name_orig} = %{version}-%{release}
Obsoletes:	%{cross_prefix}gnat-runtime
Provides:	%{cross_prefix}gnat-runtime = %{version}-%{release}
# upgrade from mga6
Obsoletes:	libgnat1

%description -n %{libgnat_name}
This package contains the shared libraries required to run programs
compiled with the GNU Ada compiler (GNAT) if they are compiled to use
shared libraries.  It also contains the shared libraries for the
Implementation of the Ada Semantic Interface Specification (ASIS), the
implementation of Distributed Systems Programming (GLADE) and the
Posix 1003.5 Binding (Florist).
%endif

####################################################################
# FFI headers and libraries
%if %{build_libffi}
%package -n %{libffi_name}
Summary:	GCC support library for FFI
Group:		System/Libraries

%description -n %{libffi_name}
This package contains GCC shared support library which is needed
for FFI support.

%package -n %{libffi_name}-devel
Summary:	Development headers and static library for FFI
Group:		Development/C
Requires:	%{libffi_name} = %{version}-%{release}
Provides:	%{libffi_name_orig}-devel = %{version}-%{release}
Obsoletes:	%{libffi_name_orig}-devel = 4.3.2
Obsoletes:	%{libffi_name_orig}-devel = 4.3.1
Obsoletes:	%{libffi_name_orig}-devel = 4.2.3
Obsoletes:	%{libffi_name_orig}-devel = 4.2.2
Provides:	ffi-devel = %{version}-%{release}

%description -n %{libffi_name}-devel
This package contains the development headers and the static library
for libffi. The libffi library provides a portable, high level
programming interface to various calling conventions. This allows a
programmer to call any function specified by a call interface
description at run time.
%endif

####################################################################
# SSP headers and libraries
%if %{build_libssp}

%package -n %{libssp_name}
Summary:	GCC SSP shared support library
Group:		System/Libraries

%description -n %{libssp_name}
This package contains GCC shared support library which is needed
for SSP support.

%package -n %{libssp_name_orig}-devel
Summary:	GCC SSP support
Group:		Development/C
Requires:	%{name} = %{version}-%{release}
%if %{libc_shared}
Requires:	%{libssp_name} = %{version}-%{release}
%endif

%description -n %{libssp_name_orig}-devel
This package contains headers and static libraries for building
SSP-instrumented programs.

Refer to the documentation for -fstack-protector.
%endif

####################################################################
# GCC OpenMP headers and library

%package -n %{libgomp_name}
Summary:	GCC OpenMP support library
Group:		System/Libraries

%description -n %{libgomp_name}
This package contains the GCC shared support library which is needed 
for OpenMP support.

%package -n %{libgomp_name_orig}-devel
Summary:	GCC OpenMP support
Group:		Development/C
Requires:	%{name} = %{version}-%{release}
%if %{libc_shared}
Requires:	%{libgomp_name} = %{version}-%{release}
%endif

%description -n %{libgomp_name_orig}-devel
This package contains headers and static libraries for building 
programs that use OpenMP.

####################################################################
# Preprocessor

%package cpp
Summary:	The C Preprocessor
Group:		Development/C
%if %{system_compiler}
Obsoletes:	gcc%{branch}-cpp
Provides:	gcc%{branch}-cpp = %{version}-%{release}
Conflicts:      gcc3.3-cpp < 3.3.6-8
%endif
Requires(post): update-alternatives
Requires(postun): update-alternatives

%description cpp
The C preprocessor is a 'macro processor' which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define 'macros,' which are abbreviations for longer
constructs.

The C preprocessor provides four separate facilities that you can use as
you see fit:

* Inclusion of header files. These are files of declarations that can be
  substituted into your program.
* Macro expansion. You can define 'macros,' which are abbreviations for 
  arbitrary fragments of C code, and then the C preprocessor will replace
  the macros with their definitions throughout the program.
* Conditional compilation. Using special preprocessing directives,
  you can include or exclude parts of the program according to various
  conditions.
* Line control. If you use a program to combine or rearrange source files
  into an intermediate file which is then compiled, you can use line
  control to inform the compiler about where each source line originated.

You should install this package if you are a programmer who is searching for
such a macro processor.


####################################################################
# Documentation

%package doc
Summary:	GCC documentation
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-doc
Provides:	gcc%{branch}-doc = %{version}-%{release}
%endif
BuildArch: noarch

%description doc
GCC is a compiler suite aimed at integrating all the optimizations and
features necessary for a high-performance and stable development
environment. This package contains the compiler documentation in INFO
pages.

%package doc-pdf
Summary:	GCC documentation
Group:		Development/Other
%if %{system_compiler}
Obsoletes:	gcc%{branch}-doc-pdf
Provides:	gcc%{branch}-doc-pdf = %{version}-%{release}
%endif
BuildArch: noarch

%description doc-pdf
GCC is a compiler suite aimed at integrating all the optimizations and
features necessary for a high-performance and stable development
environment. This package contains the compiler printable
documentation in PDF.

%package -n libstdc++-docs
Summary: Documentation for the GNU standard C++ library
Group: Development/Other
BuildArch: noarch

%description -n libstdc++-docs
Manual, doxygen generated API information and Frequently Asked Questions
for the GNU standard C++ library.

%prep
%setup -q -n %{source_dir}
%autopatch -p1

# Setup files for cross-compilation
# XXX embed uClibc / dietlibc sources? [ia64 checks for __GLIBC__]
%if %{build_cross}
sysroot=%{_prefix}/%{gcc_target_platform}
%endif
if [[ -n "$sysroot" ]]; then
mkdir sysroot
cd sysroot
[[ -d $sysroot/bin ]] &&
ln -s $sysroot/bin bin

[[ ! -d usr ]] &&
mkdir usr
%if %{build_cross_bootstrap}
[[ -f $sysroot/include/linux/version.h ]] &&
ln -s $sysroot/include usr/include
%else
[[ -f $sysroot/include/stdio.h ]] &&
ln -s $sysroot/include usr/include
%endif

[[ -f $sysroot/lib/crti.o ]] &&
ln -s $sysroot/lib lib
[[ -f $sysroot/lib64/crti.o ]] &&
ln -s $sysroot/lib64 lib64
[[ -f $sysroot/lib32/crti.o ]] &&
ln -s $sysroot/lib32 lib32
cd ../
fi

# We can actually link binaries at this stage
%if %{build_cross}
perl -pi -e '/^DRIVER_DEFINES/ .. /^gcc/ and s/(\@TARGET_SYSTEM_ROOT_DEFINE\@)/-DSYSROOT_SPEC="\\"\\"" \1/' gcc/Makefile.in
%endif

# Ensure BASE-VER alwaus matches rpm version
echo "%{version}" > gcc/BASE-VER

%build
# Prepare OPT_FLAGS
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g' -e 's/-mcpu=pentiumpro//g'`
%if %{build_debug}
OPT_FLAGS=`echo "$OPT_FLAGS -g" | sed -e "s/-fomit-frame-pointer//g"`
%endif
%if %{build_cross}
OPT_FLAGS="-O2 -g -pipe"
%endif
%if %isarch %{biarches}
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/\(-m64\|-m32\)//g'`
%endif
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-fomit-frame-pointer//g'`

# don't build crt files with -fasynchronous-unwind-tables
case " $OPT_FLAGS " in
*" -fasynchronous-unwind-tables "*)
  perl -pi -e 's/-fno-exceptions /-fno-exceptions -fno-asynchronous-unwind-tables /' gcc/Makefile.in
  ;;
esac

# Force a seperate object dir
rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

# Make bootstrap-lean
LANGUAGES="c"
%if %{build_cxx}
LANGUAGES="$LANGUAGES,c++"
%endif
%if %{build_ada}
LANGUAGES="$LANGUAGES,ada"
%endif
%if %{build_fortran}
LANGUAGES="$LANGUAGES,fortran"
%endif
%if %{build_objc}
LANGUAGES="$LANGUAGES,objc"
%if %{build_objc_gc}
LIBOBJC_FLAGS="--enable-objc-gc"
%endif
%endif
%if %{build_objcp}
LANGUAGES="$LANGUAGES,obj-c++"
%endif
PROGRAM_SUFFIX=""
%if "%{program_suffix}" != ""
PROGRAM_SUFFIX="--program-suffix=%{program_suffix}"
%endif
PROGRAM_PREFIX=""
%if "%{program_prefix}" != ""
PROGRAM_PREFIX="--program-prefix=%{program_prefix}"
%endif
%if %{build_cxx}
LIBSTDCXX_FLAGS="--enable-long-long --enable-__cxa_atexit --disable-libunwind-exceptions"
case %{libc} in
glibc)		LIBSTDCXX_FLAGS="$LIBSTDCXX_FLAGS --enable-clocale=gnu";;
esac
%endif
SSP_FLAGS="--disable-ssp --disable-libssp"
%if %{build_libssp}
SSP_FLAGS="--enable-ssp --enable-libssp"
%endif
%if %{use_ssp_glibc}
SSP_FLAGS="--enable-ssp --disable-libssp"
%endif
%if !%{build_quadmath}
QUADMATH_FLAGS="--disable-quadmath"
%endif
%if !%{build_libgomp}
LIBGOMP_FLAGS="--disable-libgomp"
%endif
%if %{build_isl}
ISL_FLAGS="--with-isl"
%endif
%if !%{build_libffi}
LIBFFI_FLAGS="--disable-libffi"
%endif
%if %{build_cross}
CROSS_FLAGS="--with-build-sysroot=$PWD/../sysroot --with-headers --disable-nls"
%endif
%if %{build_cross_bootstrap}
CROSS_FLAGS="--disable-threads"
%endif
%if !%{system_compiler} && !%{build_stdcxxheaders}
LIBSTDCXX_FLAGS="$LIBSTDCXX_FLAGS --with-gxx-include-dir=%{libstdcxx_includedir}"
%endif
[[ -n "$CROSS_FLAGS" ]] && CROSS_FLAGS="$CROSS_FLAGS --target=%{gcc_target_platform}"
case %{libc} in
%if %{build_cross_bootstrap}
glibc)		LIBC_FLAGS="";;
%else
glibc)		LIBC_FLAGS="--enable-threads=posix --with-linker-hash-style=gnu";;
%endif
newlib)		LIBC_FLAGS="--with-newlib --with-headers --disable-threads";;
*)		echo "ERROR: unsupported %{libc} C library"; exit 1;;
esac
%if %{libc_shared}
LIBC_FLAGS="$LIBC_FLAGS --enable-shared"
%else
LIBC_FLAGS="$LIBC_FLAGS --disable-shared"
%endif
# target specific flags (don't %ifarch for cross compilers)
case %{target_cpu} in
x86_64)		TARGET_FLAGS="--with-cpu=generic";;
i?86|athlon)	TARGET_FLAGS="--with-cpu=generic";;
armv7hl)     TARGET_FLAGS=" --with-arch=armv7-a --with-float=hard --with-fpu=vfpv3-d16 --with-abi=aapcs-linux";;
esac

# (anssi) building with external jar fails
%define python_dir %(echo "%{py_puresitedir}" | sed 's!^%{_prefix}!!g')
CC="%{__cc}" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --libexecdir=%{_prefix}/lib --with-slibdir=%{target_slibdir} \
	--with-pkgversion="Mageia %{version}-%{release}" --with-bugurl=https://bugs.mageia.org/ \
	--mandir=%{_mandir} --infodir=%{_infodir} --enable-checking=release \
	--enable-languages="$LANGUAGES" $PROGRAM_PREFIX $PROGRAM_SUFFIX --enable-linker-build-id \
	--build=%{_target_platform} --host=%{_target_platform} $CROSS_FLAGS $TARGET_FLAGS \
	--with-system-zlib $LIBC_FLAGS $LIBOBJC_FLAGS $LIBSTDCXX_FLAGS $SSP_FLAGS \
	$QUADMATH_FLAGS $LIBFFI_FLAGS --disable-werror $LIBGOMP_FLAGS \
	$ISL_FLAGS --with-python-dir=%{python_dir} --enable-lto
touch ../gcc/c-gperf.h
%if %{build_cross}
%make
%else
# bootstrap-lean is similar to bootstrap except "object files from the stage1
# and stage2 of the 3-stage bootstrap of the compiler are deleted as soon as
# they are no longer needed."
%make bootstrap-lean BOOT_CFLAGS="$OPT_FLAGS"
%endif

cd ..

# Copy various doc files here and there
mkdir -p rpm.doc/gfortran
mkdir -p rpm.doc/objc
mkdir -p rpm.doc/objcp
mkdir -p rpm.doc/libobjc
mkdir -p rpm.doc/boehm-gc
mkdir -p rpm.doc/c++
mkdir -p rpm.doc/libstdc++

%if %{build_libstdcxx}
(cd libstdc++-v3; for i in ChangeLog*; do
	ln -f $i ../rpm.doc/libstdc++/$i
done)
%endif
%if %{build_cxx}
(cd gcc/cp; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/c++/$i
done)
%endif
%if %{build_fortran}
(cd gcc/fortran; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/gfortran/$i
done)
(cd libgfortran; for i in ChangeLog*; do
	ln -f $i ../rpm.doc/gfortran/$i.libgfortran
done)
%endif
%if %{build_objc}
(cd gcc/objc; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in ChangeLog*; do
	ln -f $i ../rpm.doc/libobjc/$i.libobjc
done)
%endif
%if %{build_objcp}
(cd gcc/objcp; for i in ChangeLog*; do
	ln -f $i ../../rpm.doc/objcp/$i.objcp
done)
%endif

# [ghibo] - build printable documentation
%if %{build_pdf_doc}
export PDFTEX=pdftex
unset TEXINPUTS
(cd gcc/doc; for file in gcc.texi cpp.texi cppinternals.texi; do
  texi2dvi -p -t @afourpaper -t @finalout -I ./include -I ../../obj-%{gcc_target_platform}/gcc $file
done)
(cd gcc/fortran;
  texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include -I ../../obj-%{gcc_target_platform}/gcc gfortran.texi)
%if %{build_ada}
(cd gcc/ada;
  texi2dvi -p -t @afourpaper -t @finalout -I ../doc/include -I ../../obj-%{gcc_target_platform}/gcc gnat_rm.texi)
(cd obj-%{gcc_target_platform}/gcc/doc;
  texi2dvi -p -t @afourpaper -t @finalout -I ../../../gcc/doc/include -I .. gnat_ugn.texi
  mv gnat_ugn.pdf ../../../gcc/ada/gnat_ugn.pdf)
%endif
%endif

# Make generated doxygen pages.
%if %{build_libstdcxx_docs}
cd obj-%{gcc_target_platform}/%{gcc_target_platform}/libstdc++-v3
make doc-html-doxygen
make doc-man-doxygen
cd ../..
%endif

%check
echo ====================TESTING=========================
%if %{build_check}
cd obj-%{gcc_target_platform}
time %make -k check || true
echo "XXX check time above XXX"
../contrib/test_summary > ../test_summary.log
cd ..
%endif
echo ====================TESTING END=====================
 
%install
# Create some directories, just to make sure (e.g. ColorGCC)
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}
mkdir -p %{buildroot}%{_infodir}
mkdir -p %{buildroot}%{_sysconfdir}

pushd obj-%{gcc_target_platform};
  %makeinstall_std
%if %{build_libstdcxx_docs}
  libstdcxx_doc_builddir=%{gcc_target_platform}/libstdc++-v3/doc/doxygen
  mkdir -p ../rpm.doc/libstdc++-v3
  cp -r -p ../libstdc++-v3/doc/html ../rpm.doc/libstdc++-v3/html
  cp -r -p $libstdcxx_doc_builddir/html ../rpm.doc/libstdc++-v3/html/api
  mkdir -p %{buildroot}%{_mandir}/man3
  cp -r -p $libstdcxx_doc_builddir/man/man3/* %{buildroot}%{_mandir}/man3/
%endif
popd

FULLVER=`%{buildroot}%{_bindir}/%{gcc_target_platform}-gcc%{program_suffix} --version | head -n 1 | cut -d' ' -f3`
FULLPATH=$(dirname %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/cc1)

# Create /usr/bin/%{program_prefix}gcc%{branch}-version that contains the full version of gcc
cat >%{buildroot}%{_bindir}/%{program_prefix}gcc%{branch}-version <<EOF
#!/bin/sh
echo "$FULLVER"
EOF
chmod 0755 %{buildroot}%{_bindir}/%{program_prefix}gcc%{branch}-version

%if "%{program_suffix}" == ""
mv %{buildroot}%{_bindir}/%{program_prefix}cpp %{buildroot}%{_bindir}/%{program_prefix}cpp-%{version}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc %{buildroot}%{_bindir}/%{program_prefix}gcc-%{version}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc-ar %{buildroot}%{_bindir}/%{program_prefix}gcc-ar-%{version}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc-nm %{buildroot}%{_bindir}/%{program_prefix}gcc-nm-%{version}
mv %{buildroot}%{_bindir}/%{program_prefix}gcc-ranlib %{buildroot}%{_bindir}/%{program_prefix}gcc-ranlib-%{version}
%if %{build_cxx}
mv %{buildroot}%{_bindir}/%{program_prefix}g++ %{buildroot}%{_bindir}/%{program_prefix}g++-%{version}
mv %{buildroot}%{_bindir}/%{program_prefix}c++ %{buildroot}%{_bindir}/%{program_prefix}c++-%{version}
%endif
%endif

# replacing hardlinks with symlinks
ln -sf %{program_prefix}gcc%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc%{program_suffix}
ln -sf %{program_prefix}gcc-ar%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-ar%{program_suffix}
ln -sf %{program_prefix}gcc-nm%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-nm%{program_suffix}
ln -sf %{program_prefix}gcc-ranlib%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-ranlib%{program_suffix}
ln -sf %{program_prefix}gcc-ar%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ar%{program_suffix}
ln -sf %{program_prefix}gcc-nm%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-nm%{program_suffix}
ln -sf %{program_prefix}gcc-ranlib%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ranlib%{program_suffix}
# TODO: cleanups?
%if "%{program_prefix}" != "%{gcc_target_platform}-"
ln -sf %{program_prefix}gcc%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gcc-%{version}
ln -sf %{program_prefix}gcc-ar%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ar-%{version}
ln -sf %{program_prefix}gcc-nm%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-nm-%{version}
ln -sf %{program_prefix}gcc-ranlib%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-ranlib-%{version}
%endif
%if %{build_cxx}
%if !%{build_cross}
ln -sf %{program_prefix}g++%{program_long_suffix} %{buildroot}%{_bindir}/c++%{program_long_suffix}
%endif
ln -sf %{program_prefix}g++%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-c++%{program_suffix}
ln -sf %{program_prefix}g++%{program_long_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-g++%{program_suffix}
%endif
%if %{build_fortran}
ln -sf %{program_prefix}gfortran%{program_suffix} %{buildroot}%{_bindir}/%{gcc_target_platform}-gfortran%{program_suffix}
%endif

%if %{system_compiler}
ln -s gcc %{buildroot}%{_bindir}/cc
%endif

%if %{build_cross_bootstrap}
# libgcc_eh.a is needed for glibc _but_ it is not built at this stage
# (disabled-shared)
# workaround by symlinking to libgcc. The other possibility would be to
# workaround at glibc level but it would be more painful.
ln -sf %{gcc_libdir}/%{gcc_target_platform}/%{version}/libgcc.a \
	%{buildroot}/%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgcc_eh.a
%endif
rm -f %{buildroot}%{_infodir}/dir

%if %{build_ada} && %{libc_shared}
%if %isarch x86_64
rm -rf $FULLPATH/32/ada{include,lib}
%endif
# Dispatch Ada 95 libraries (special case)
pushd $FULLPATH/adalib
  rm -f libgnarl.so* libgnat.so*
  mv -f libgnarl-%{libgnat_major}.so %{buildroot}%{_libdir}/
  ln -s ../../../../../%{_lib}/libgnarl-%{libgnat_major}.so libgnarl.so
  ln -s ../../../../../%{_lib}/libgnarl-%{libgnat_major}.so libgnarl-%{libgnat_major}.so
  mv -f libgnat-%{libgnat_major}.so %{buildroot}%{_libdir}/
  ln -s ../../../../../%{_lib}/libgnat-%{libgnat_major}.so libgnat.so
  ln -s ../../../../../%{_lib}/libgnat-%{libgnat_major}.so libgnat-%{libgnat_major}.so
popd
%endif

# Strip debug info from libraries
STRIP_DEBUG=/bin/true
%if !%{build_debug}
if [[ "%{_enable_debug_packages}" != "1" ]]; then
  STRIP_DEBUG="strip -g"
  if [[ "%{_target_cpu}" != "%{target_cpu}" ]]; then
    STRIP_DEBUG="%{target_cpu}-linux-$STRIP_DEBUG"
  fi
fi
%endif

# Dispatch libraries to the right directories
DispatchLibs() {
	libname=$1 libversion=$2
	[[ -f ../../../../..%{target_libdir}/$libname.so.$libversion ]] && {
	$STRIP_DEBUG ../../../../..%{target_libdir}/$libname.so.$libversion
	rm -f $libname.so
	ln -s ../../../../..%{target_libdir}/$libname.so.$libversion $libname.so
	rm -f ../../../../..%{target_libdir}/$libname.so
	} || :
	[[ -f ../../../../..%{target_libdir}/$libname.a ]] && {
	$STRIP_DEBUG ../../../../..%{target_libdir}/$libname.a
	rm -f $libname.a
	cp -f ../../../../..%{target_libdir}/$libname.a $libname.a
	rm -f ../../../../..%{target_libdir}/$libname.a
	} || :
	%if %isarch %{biarches}
	[ -d 32 ] || mkdir 32
	pushd 32
	mkdir -p %{buildroot}%{_prefix}/lib
	skip32=
	[[ -z "$skip32" ]] && [[ -f ../../../../$libname.so.$libversion ]] && {
	$STRIP_DEBUG ../../../../$libname.so.$libversion
	ln -s ../../../../$libname.so.$libversion $libname.so
	rm -f ../../../../$libname.so
	[[ -f ../../../../$libname.a ]] && {
	$STRIP_DEBUG ../../../../$libname.a
	cp -f ../../../../$libname.a $libname.a
	rm -f ../../../../$libname.a
	} || :
	} || :
	popd
	%endif
	%if %isarch %{nof_arches}
	[ -d nof ] || mkdir nof
	pushd nof
	$STRIP_DEBUG ../../../../nof/$libname.so.$libversion
	ln -s ../../../../nof/$libname.so.$libversion $libname.so
	rm -f ../../../../nof/$libname.so
	[[ -f ../../../../nof/$libname.a ]] && {
	$STRIP_DEBUG ../../../../nof/$libname.a
	cp -f ../../../../nof/$libname.a $libname.a
	rm -f ../../../../nof/$libname.a
	} || :
	popd
	%endif
}
pushd $FULLPATH
	%if %{build_libssp}
	DispatchLibs libssp		%{libssp_major}.0.0
	mv ../../../../..%{target_libdir}/libssp_nonshared.a libssp_nonshared.a
	%if %isarch %{biarches}
	mv ../../../libssp_nonshared.a 32/libssp_nonshared.a
	%endif
	%endif
        %if %{build_libgomp}
	DispatchLibs libgomp		%{libgomp_major}.0.0
        %endif
	%if %{build_cxx}
	DispatchLibs libstdc++	%{libstdcxx_major}.0.%{libstdcxx_micro}
	mv ../../../../..%{target_libdir}/libsupc++.a libsupc++.a
	%if %isarch %{biarches}
	mv -f ../../../libsupc++.a 32/libsupc++.a
	%endif
	%if %isarch %{nof_arches}
	mv -f ../../../nof/libsupc++.a nof/libsupc++.a
	%endif
	%endif
	# Make it less hard dependent on libstdc++ 3.4 minor changes
	%if !%{system_compiler}
	[[ -f  ../../../../..%{target_libdir}/libstdc++.so.%{libstdcxx_major} ]] &&
	ln -sf ../../../../..%{target_libdir}/libstdc++.so.%{libstdcxx_major} libstdc++.so || :
	%if %isarch %{biarches}
	[[ -f  ../../../libstdc++.so.%{libstdcxx_major} ]] &&
	ln -sf ../../../../libstdc++.so.%{libstdcxx_major} 32/libstdc++.so || :
	%endif
	%endif
	%if %{build_objc}
	DispatchLibs libobjc	%{libobjc_major}.0.0
	%if %{build_objc_gc}
	DispatchLibs libobjc_gc	%{libobjc_major}.0.0
	%endif
	%endif
	%if %{build_fortran}
	DispatchLibs libgfortran	%{libgfortran_major}.0.0
	[[ -f ../../../libgfortranbegin.a ]] &&
	mv -f ../../../libgfortranbegin.a 32/libgfortranbegin.a || :
	%if %isarch %{nof_arches}
	[[ -f ../../../nof/libgfortranbegin.a ]] &&
	mv -f ../../../nof/libgfortranbegin.a nof/libgfortranbegin.a || :
	%endif
	%endif
popd

# Copy <cxxabi.h> to compiler-specific directories to keep backward compatibility
%if %{build_cxx}
mkdir -p $FULLPATH/include/bits/
cp %{buildroot}%{libstdcxx_includedir}/cxxabi.h $FULLPATH/include/
cp %{buildroot}%{libstdcxx_includedir}/%{gcc_target_platform}/bits/cxxabi_tweaks.h $FULLPATH/include/bits/
%endif

# Ship with biarch c++config.h headers
%if %{build_cxx}
pushd obj-%{gcc_target_platform}
cxxconfig="`find %{gcc_target_platform}/libstdc++-v3/include -name c++config.h`"
for i in `find %{gcc_target_platform}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    file_32=x file_64=x
    case $i in
      %{gcc_target_platform}/32/*) file_32=$i; file_64=$cxxconfig ;;
      %{gcc_target_platform}/64/*) file_32=$cxxconfig; file_64=$i ;;
    esac
    { [[ -f "$file_32" ]] && [[ -f "$file_64" ]]; } ||
      { echo "c++config.h dispatch error"; exit 1; }

    cat > %{buildroot}%{libstdcxx_includedir}/%{gcc_target_platform}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
`cat $file_32`
#else
`cat $file_64`
#endif
#endif
EOF
    break
  fi
done
popd
%endif

# Link gnatgcc to gcc
%if %{build_ada}
ln -sf gcc %{buildroot}%{_bindir}/gnatgcc
%endif

# Create an empty file with perms 0755
FakeAlternatives() {
  for file in ${1+"$@"}; do
    rm -f %{cross_program_prefix}$file
    touch %{cross_program_prefix}$file
    chmod 0755 %{cross_program_prefix}$file
  done
}

# Alternatives provide /lib/cpp and %{_bindir}/cpp
(cd %{buildroot}%{_bindir}; FakeAlternatives cpp)
%if !%{build_cross} && %{system_compiler}
(mkdir -p %{buildroot}/lib; cd %{buildroot}/lib; ln -sf %{_bindir}/cpp cpp)
%endif

# Alternatives provide /usr/bin/c++
%if %{build_cxx}
(cd %{buildroot}%{_bindir}; FakeAlternatives c++)
%endif

if [[ -z "%{?cross_bootstrap:1}" ]] && [[ "%{libc_shared}" = "1" ]]; then
# Move libgcc_s.so* to /%{_lib}
pushd %{buildroot}%{_prefix}/%{target_lib}
  chmod 0755 libgcc_s.so.%{libgcc_major}
  mkdir -p %{buildroot}%{target_slibdir}
  mv -f  libgcc_s.so.%{libgcc_major} %{buildroot}%{target_slibdir}/libgcc_s-%{version}.so.%{libgcc_major}
  ln -sf libgcc_s-%{version}.so.%{libgcc_major} %{buildroot}%{target_slibdir}/libgcc_s.so.%{libgcc_major}
  # WARNING:
  # if there's a libgcc_s.so, it's a linker script. should be used instead of libgcc_s.so.*
  # to avoid build errors. At least ARM need this kind of specific care.
  if [ -f %{buildroot}/usr/%{target_lib}/libgcc_s.so ]; then
    mkdir -p %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}
    mv -f %{buildroot}/usr/%{target_lib}/libgcc_s.so %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/
  else
    ln -sf %{target_slibdir}/libgcc_s.so.%{libgcc_major} %{buildroot}%{target_libdir}/libgcc_s.so
  fi
%if %isarch %{nof_arches}
  chmod 0755 nof/libgcc_s.so.%{libgcc_major}
  mkdir -p %{buildroot}%{target_slibdir}/nof
  mv -f  nof/libgcc_s.so.%{libgcc_major} %{buildroot}%{target_slibdir}/nof/libgcc_s-%{version}.so.%{libgcc_major}
  ln -sf libgcc_s-%{version}.so.%{libgcc_major} %{buildroot}%{target_slibdir}/nof/libgcc_s.so.%{libgcc_major}
  ln -sf %{target_slibdir}/nof/libgcc_s.so.%{libgcc_major} %{buildroot}%{target_libdir}/nof/libgcc_s.so
%endif
popd
%if %isarch %{biarches}
pushd %{buildroot}%{_prefix}/lib
  chmod 0755 libgcc_s.so.%{libgcc_major}
  mkdir -p %{buildroot}/lib
  mv -f  libgcc_s.so.%{libgcc_major} %{buildroot}/lib/libgcc_s-%{version}.so.%{libgcc_major}
  ln -sf libgcc_s-%{version}.so.%{libgcc_major} %{buildroot}/lib/libgcc_s.so.%{libgcc_major}
  ln -sf ../../lib/libgcc_s.so.%{libgcc_major} %{buildroot}%{_prefix}/lib/libgcc_s.so
  ln -sf ../../lib/libgcc_s.so.%{libgcc_major} %{buildroot}%{_prefix}/lib/libgcc_s_32.so
popd
%endif
fi

# Create c89 and c99 wrappers
%if %{system_compiler}
cat > %{buildroot}%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_bindir}/gcc-%{version} $fl ${1+"$@"}
EOF
cat > %{buildroot}%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_bindir}/gcc-%{version} $fl ${1+"$@"}
EOF
chmod 755 %{buildroot}%{_prefix}/bin/c?9
%endif

# FIXME: cpp, gcov manpages names
pushd %{buildroot}%{_mandir}/man1;
  if [[ -n "%{program_prefix}%{program_suffix}" ]]; then
    for f in gcov cpp gcc g++ gfortran; do
      [[ -f "$f.1" ]] && mv $f.1 %{program_prefix}$f%{program_suffix}.1 || :
    done
  fi
popd

# Fix info pages
if [[ "%{name}" = "gcc%{branch}" ]]; then
  pushd %{buildroot}%{_infodir}/
  for f in cpp cppinternals gcc gfortran gnat-style gnat_rm gnat_ugn; do
    if [[ -f "$f.info" ]]; then
      perl -pe "/^START-INFO-DIR-ENTRY/ .. /^END-INFO-DIR-ENTRY/ and s/($f)/\${1}-%{branch}/ig" $f.info > ${f}-%{branch}.info
      rm -f $f.info
    fi
  done
  popd
fi

# Sanitize rpath
for bin in %{buildroot}%{_bindir}/* $FULLPATH/*.so $FULLPATH/ecj1; do
  if [[ ! -f $bin ]]; then
    continue
  fi
  oldrpath=$(chrpath -l $bin | awk -F= '{ print $2 }')
  newrpath=
  for rpathdir in ${oldrpath//:/ }; do
    rpathdir=${rpathdir/lib\/..\/lib64/lib64}
    [[ "$rpathdir" != "%{_libdir}" ]] || continue
    newrpath=$newrpath:$rpathdir
  done
  newrpath=${newrpath#:}
  [[ "$newrpath" != "$oldrpath" ]] || continue
  if [[ "$newrpath" == "" ]]; then
    chrpath -d $bin
  else
    chrpath -r $newrpath $bin
  fi
done

%if %{system_compiler}
%define find_lang /usr/lib/rpm/find-lang.sh %buildroot
%find_lang %{name}
%find_lang cpplib
%if %{build_cxx}
%find_lang libstdc++
%endif
%else
touch %{name}.lang cpplib.lang libstdc++.lang
%endif

# Remove unpackaged files
rm  -f %{buildroot}%{_bindir}/jar
rm  -f %{buildroot}%{_bindir}/addr2name.awk
rm -rf %{buildroot}%{_prefix}/doc
rm -rf %{buildroot}%{_mandir}/man7
rm  -f %{buildroot}%{target_libdir}/*.la
rm  -f %{buildroot}%{_prefix}/lib/libiberty.a
rm  -f %{buildroot}%{_prefix}/lib64/libiberty.a
rm  -f %{buildroot}%{target_libdir}*/libiberty.a
%if %isarch %{biarches}
rm  -f %{buildroot}%{_prefix}/lib/*.la
rm  -f %{buildroot}%{_prefix}/lib/32/libiberty.a
%endif
rm -rf %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/install-tools
%if !%{build_doc}
rm -fr %{buildroot}/%{_datadir}/info/
%endif
%if !%{build_quadmath}
rm -f %{buildroot}/%{_datadir}/info/libquadmath*
%endif

%if %{build_cross}
rm %{buildroot}%{_mandir}/man1/%{program_prefix}gcov%{program_suffix}.1*
rm %{buildroot}%{_bindir}/%{program_prefix}gcov%{program_suffix}
%endif


%if !%system_compiler && !%build_cross && %libc_shared
rm %{buildroot}%{target_slibdir}/libgcc_s-%{version}.so.%{libgcc_major}
rm %{buildroot}%{target_slibdir}/libgcc_s.so.%{libgcc_major}
rm %{buildroot}%{target_libdir}/libgcc_s.so
%if %isarch %{biarches}
rm %{buildroot}%{target_slibdir32}/libgcc_s-%{version}.so.%{libgcc_major}
rm %{buildroot}%{target_slibdir32}/libgcc_s.so.%{libgcc_major}
rm %{buildroot}%{target_libdir}/../lib/libgcc_s.so
rm %{buildroot}%{target_libdir}/../lib/libgcc_s_32.so
%endif
%endif
%if %build_cross && !%{build_cross_bootstrap}
rm -f %{buildroot}/usr/%{target_lib}/libgcc_s.so
%endif

# lsan is only available on x86_64, no need to expose header on other arches
%ifnarch x86_64 aarch64
rm -f %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/sanitizer/lsan_interface.h
%endif

# limits.h and syslimits.h are needed in includedir
mv %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/include-fixed/{sys,}limits.h \
	%{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/include
rm -r %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/include-fixed

%if !%{system_compiler}
rm -f %{buildroot}%{_infodir}/gccinstall.info*
rm -f %{buildroot}%{_infodir}/gccint.info*
rm -rf %{buildroot}%{_datadir}/locale
%endif
rm -f %{buildroot}%{_infodir}/cp-tools.info

# In case we are cross-compiling, don't bother to remake symlinks and
# don't let spec-helper when stripping files either
%if %build_cross
export DONT_SYMLINK_LIBS=1
export DONT_STRIP=1
%endif

%if %{build_debug}
# Don't strip in debug mode
export DONT_STRIP=1
%endif

%if %{build_libstdcxx}
%if %build_cross && !%{build_cross_bootstrap}
rm -f %{buildroot}%{target_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py
%else
mkdir -p %{buildroot}%{_datadir}/gdb/auto-load/%{_libdir}
mv -f %{buildroot}%{_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py \
      %{buildroot}%{_datadir}/gdb/auto-load/%{_libdir}/
%if %isarch %{biarches}
mkdir -p %{buildroot}%{_datadir}/gdb/auto-load/%{_prefix}/lib
mv -f %{buildroot}%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py \
      %{buildroot}%{_datadir}/gdb/auto-load/%{_prefix}/lib/
%endif
%endif
%endif

# fix experimental/filesystem .a location
%if %{build_libstdcxx}
mv -f %{buildroot}%{_libdir}/libstdc++fs.a %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/
%if %isarch %{biarches}
mv -f %{buildroot}%{_prefix}/lib/libstdc++fs.a %{buildroot}%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/
%endif
%endif

# fix links broken by /usr move
rm -f %{buildroot}/lib/cpp
ln -sf %{_bindir}/cpp %{buildroot}%{_prefix}/lib/cpp

%post
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc %{cross_program_prefix}gcc %{_bindir}/%{program_prefix}gcc-%{version} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc-ar %{cross_program_prefix}gcc-ar %{_bindir}/%{program_prefix}gcc-ar-%{version} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc-ar ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc-ar
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc-nm %{cross_program_prefix}gcc-nm %{_bindir}/%{program_prefix}gcc-nm-%{version} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc-nm ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc-nm
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}gcc-ranlib %{cross_program_prefix}gcc-ranlib %{_bindir}/%{program_prefix}gcc-ranlib-%{version} %{alternative_priority}
[ -e %{_bindir}/%{cross_program_prefix}gcc-ranlib ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}gcc-ranlib

%postun
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-%{version} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc %{_bindir}/%{program_prefix}gcc-%{version}
fi
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-ar-%{version} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc-ar %{_bindir}/%{program_prefix}gcc-ar-%{version}
fi
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-nm-%{version} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc-nm %{_bindir}/%{program_prefix}gcc-nm-%{version}
fi
if [ ! -f %{_bindir}/%{cross_program_prefix}gcc-ranlib-%{version} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}gcc-ranlib %{_bindir}/%{program_prefix}gcc-ranlib-%{version}
fi

%if %{build_cxx}
%post c++
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}g++ %{cross_program_prefix}g++ %{_bindir}/%{program_prefix}g++-%{version} %{alternative_priority} --slave %{_bindir}/%{cross_program_prefix}c++ %{cross_program_prefix}c++ %{_bindir}/%{program_prefix}g++-%{version}
[ -e %{_bindir}/%{cross_program_prefix}g++ ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}g++

%postun c++
if [ ! -f %{_bindir}/%{cross_program_prefix}g++-%{version} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}g++ %{_bindir}/%{program_prefix}g++-%{version}
fi
%endif

%post cpp
/usr/sbin/update-alternatives --install %{_bindir}/%{cross_program_prefix}cpp %{cross_program_prefix}cpp %{_bindir}/%{program_prefix}cpp-%{version} %{alternative_priority} --slave /lib/%{cross_program_prefix}cpp %{cross_program_prefix}lib_cpp %{_bindir}/%{program_prefix}cpp-%{version}
[ -e %{_bindir}/%{cross_program_prefix}cpp ] || /usr/sbin/update-alternatives --auto %{cross_program_prefix}cpp

%postun cpp
if [ ! -f %{_bindir}/%{cross_program_prefix}cpp-%{version} ]; then
  /usr/sbin/update-alternatives --remove %{cross_program_prefix}cpp %{_bindir}/%{program_prefix}cpp-%{version}
fi

%files -f %{name}.lang
#
%doc gcc/README*
%{_mandir}/man1/%{program_prefix}gcc%{program_suffix}.1*
%if "%{name}" == "gcc%{package_suffix}"
%{_mandir}/man1/gcov%{program_suffix}.1*
%{_mandir}/man1/gcov-dump%{program_suffix}.1*
%{_mandir}/man1/gcov-tool%{program_suffix}.1*
%endif
#
%{_bindir}/%{program_prefix}gcc%{branch}-version
%{_bindir}/%{program_prefix}gcc%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc%{program_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-%{version}
%{_bindir}/%{program_prefix}gcc-ar%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-ar%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ar%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ar-%{version}
%{_bindir}/%{program_prefix}gcc-nm%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-nm%{program_suffix}
%{_bindir}/%{gcc_target_platform}-nm%{program_suffix}
%{_bindir}/%{gcc_target_platform}-nm-%{version}
%{_bindir}/%{program_prefix}gcc-ranlib%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-gcc-ranlib%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ranlib%{program_suffix}
%{_bindir}/%{gcc_target_platform}-ranlib-%{version}
%if "%{name}" == "gcc%{package_suffix}"
%{_bindir}/gcov%{program_suffix}
%{_bindir}/gcov-dump
%{_bindir}/gcov-tool
%endif
%if %{system_compiler}
%{_bindir}/cc
%{_bindir}/c89
%{_bindir}/c99
%endif
#
%if %{libc_shared} && %{build_cross} || %{system_compiler}
%if !%{build_cross_bootstrap}
%{target_libdir}/libcc1.so
%if %isarch %arm %{ix86} x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgcc_s.so
%else
%{target_libdir}/libgcc_s.so
%endif
%endif
%if "%{name}" == "gcc%{package_suffix}"
%if %isarch %{nof_arches}
%{_libdir}/nof/libgcc_s.so
%endif
%if %isarch %{biarches}
%{_prefix}/lib/libgcc_s.so
%{_prefix}/lib/libgcc_s_32.so
%endif
%endif
%endif
#
%dir %{gcc_libdir}/%{gcc_target_platform}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}
#
%{gcc_libdir}/%{gcc_target_platform}/%{version}/collect2
%{gcc_libdir}/%{gcc_target_platform}/%{version}/crt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgcc.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgcov.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/lto-wrapper
%{gcc_libdir}/%{gcc_target_platform}/%{version}/lto1
# TODO: split out?
%{gcc_libdir}/%{gcc_target_platform}/%{version}/liblto_plugin*
# TODO: split out
%{gcc_libdir}/%{gcc_target_platform}/%{version}/plugin/libcp1plugin*

%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgcc_eh.a
%if "%{name}" == "gcc%{package_suffix}"
%if %isarch %{biarches}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/32
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/crt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libgcc.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libgcc_eh.a
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libgcov.a
%endif
%if %isarch %{nof_arches}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/nof
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/crt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/ecrt*.o
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libgcc.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libgcc_eh.a
%endif
%endif
%endif
#
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/include
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/float.h
%if %isarch %{ix86} x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/adxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/ammintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx2intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx5124fmapsintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx5124vnniwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512bitalgintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512bwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512cdintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512dqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512erintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512fintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512ifmaintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512ifmavlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512pfintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vbmi2intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vbmiintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vbmi2vlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vbmivlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vlbwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vldqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vnniintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vnnivlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vpopcntdqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/avx512vpopcntdqvlintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/bmiintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/bmi2intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/bmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/cet.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/cetintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/clflushoptintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/clwbintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/clzerointrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/emmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/f16cintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/fma4intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/fmaintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/fxsrintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/gfniintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/ia32intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/immintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/lwpintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/lzcntintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/mm_malloc.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/mm3dnow.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/mmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/mwaitxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/movdirintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/nmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/pconfigintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/pkuintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/pmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/popcntintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/prfchwintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/rdseedintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/rtmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/sgxintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/shaintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/smmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/tbmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/tmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/vaesintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/vpclmulqdqintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/wbnoinvdintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/wmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/x86intrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/xmmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/xopintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/xsavecintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/xsaveintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/xsaveoptintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/xsavesintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/xtestintrin.h
%endif
%if %isarch %arm
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/mmintrin.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/arm_cmse.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/unwind-arm-common.h
%endif
%if %isarch %arm aarch64
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/arm_acle.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/arm_fp16.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/arm_neon.h
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/gcov.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/iso646.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/limits.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdalign.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdarg.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdatomic.h
%if %isarch %{ix86} x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/cross-stdarg.h
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdbool.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stddef.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdint-gcc.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdint.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdnoreturn.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/syslimits.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/unwind.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/varargs.h
%if %isarch i386 x86_64
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/cpuid.h
%endif
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/stdfix.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/sanitizer/common_interface_defs.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/sanitizer/tsan_interface.h

%if "%{name}" == "%{cross_prefix}gcc" && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libgcc_name}
%endif
%{target_libdir}/libcc1.so.%{libcc_major}
%{target_libdir}/libcc1.so.%{libcc_major}.0.0
%{target_slibdir}/libgcc_s-%{version}.so.%{libgcc_major}
%{target_slibdir}/libgcc_s.so.%{libgcc_major}
%if %isarch %{biarches}
%{target_slibdir32}/libgcc_s-%{version}.so.%{libgcc_major}
%{target_slibdir32}/libgcc_s.so.%{libgcc_major}
# (cg) Excluded for usrmerge
# Note: This file will be recreated when running ldconfig so it will likely
# return almost immediately on installed systems but due to a file name conflict
# when the usrmerge happens it *must* be excluded from the package.
# In the fullness of time we can remove any /lib vs /usr/lib hacks in this package.
%exclude %{_prefix}/lib/libgcc_s.so.%{libgcc_major}
%endif
%if %isarch %{nof_arches}
%{target_slibdir}/nof/libgcc_s-%{version}.so.%{libgcc_major}
%{target_slibdir}/nof/libgcc_s.so.%{libgcc_major}
%endif
%endif

%if %{build_libssp} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libssp_name}
%endif
%{target_libdir}/libssp.so.%{libssp_major}
%{target_libdir}/libssp.so.%{libssp_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libssp.so.%{libssp_major}
%{_prefix}/lib/libssp.so.%{libssp_major}.0.0
%endif
%endif

%if %{build_libssp}
%if !%{build_monolithic}
%files -n %{libssp_name_orig}-devel
%endif
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/include/ssp
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/ssp/*.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libssp.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libssp_nonshared.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libssp.so
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libssp.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libssp_nonshared.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libssp.so
%endif
%endif
%endif

%if %{build_libgomp}
%files -n %{libgomp_name}
%{target_libdir}/libgomp.so.%{libgomp_major}
%{target_libdir}/libgomp.so.%{libgomp_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libgomp.so.%{libgomp_major}
%{_prefix}/lib/libgomp.so.%{libgomp_major}.0.0
%endif

%files -n %{libgomp_name_orig}-devel
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgomp.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgomp.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/omp.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/openacc.h
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libgomp.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libgomp.so
%endif
%{target_libdir}/libgomp.spec
%if %isarch %{biarches}
%{_prefix}/lib/libgomp.spec
%endif
%endif

%if %{build_quadmath}
%files -n %{libquadmath_name}
%{target_libdir}/libquadmath.so.%{libquadmath_major}
%{target_libdir}/libquadmath.so.%{libquadmath_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libquadmath.so.%{libquadmath_major}
%{_prefix}/lib/libquadmath.so.%{libquadmath_major}.0.0
%endif

%files -n %{libquadmath_name_orig}-devel
%{target_libdir}/libquadmath.a
%{target_libdir}/libquadmath.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/quadmath.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/quadmath_weak.h
%if %isarch %{biarches}
%{_prefix}/lib/libquadmath.a
%{_prefix}/lib/libquadmath.so
%endif
%endif

%if %{build_libitm}
%files -n %{libitm_name}
%{target_libdir}/libitm.so.%{libitm_major}
%{target_libdir}/libitm.so.%{libitm_major}.0.0
%{target_libdir}/libitm.spec
%if %isarch %{biarches}
%{_prefix}/lib/libitm.so.%{libitm_major}
%{_prefix}/lib/libitm.so.%{libitm_major}.0.0
%{_prefix}/lib/libitm.spec
%endif

%files -n %{libitm_name_orig}-devel
%{target_libdir}/libitm.a
%{target_libdir}/libitm.so
%if %isarch %{biarches}
%{_prefix}/lib/libitm.a
%{_prefix}/lib/libitm.so
%endif
%endif

%if %{build_libasan}
%files -n %{libasan_name}
%{target_libdir}/libasan.so.%{libasan_major}
%{target_libdir}/libasan.so.%{libasan_major}.0.0
%{target_libdir}/libasan_preinit.o
%if %isarch %{biarches}
%{_prefix}/lib/libasan.so.%{libasan_major}
%{_prefix}/lib/libasan.so.%{libasan_major}.0.0
%{_prefix}/lib/libasan_preinit.o
%endif

%files -n %{libasan_name_orig}-devel
%{target_libdir}/libasan.a
%{target_libdir}/libasan.so
%{target_libdir}/libsanitizer.spec
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/sanitizer/asan_interface.h
%if %isarch %{biarches}
%{_prefix}/lib/libasan.a
%{_prefix}/lib/libasan.so
%{_prefix}/lib/libsanitizer.spec
%endif
%endif

%if %{build_libatomic}
%files -n %{libatomic_name}
%{target_libdir}/libatomic.so.%{libatomic_major}
%{target_libdir}/libatomic.so.%{libatomic_major}.%{libatomic_minor}.0
%if %isarch %{biarches}
%{_prefix}/lib/libatomic.so.%{libatomic_major}
%{_prefix}/lib/libatomic.so.%{libatomic_major}.%{libatomic_minor}.0
%endif

%files -n %{libatomic_name_orig}-devel
%{target_libdir}/libatomic.a
%{target_libdir}/libatomic.so
%if %isarch %{biarches}
%{_prefix}/lib/libatomic.a
%{_prefix}/lib/libatomic.so
%endif
%endif

%if %{build_liblsan}
%files -n %{liblsan_name}
%{target_libdir}/liblsan.so.%{liblsan_major}
%{target_libdir}/liblsan.so.%{liblsan_major}.0.0
%{target_libdir}/liblsan_preinit.o

%files -n %{liblsan_name_orig}-devel
%{target_libdir}/liblsan.a
%{target_libdir}/liblsan.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/sanitizer/lsan_interface.h
%endif

%if %{build_libtsan}
%files -n %{libtsan_name}
%{target_libdir}/libtsan.so.%{libtsan_major}
%{target_libdir}/libtsan.so.%{libtsan_major}.0.0
%{target_libdir}/libtsan_preinit.o

%files -n %{libtsan_name_orig}-devel
%{target_libdir}/libtsan.a
%{target_libdir}/libtsan.so
%endif

%if %{build_libubsan}
%files -n %{libubsan_name}
%{target_libdir}/libubsan.so.%{libubsan_major}
%{target_libdir}/libubsan.so.%{libubsan_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libubsan.so.%{libubsan_major}
%{_prefix}/lib/libubsan.so.%{libubsan_major}.0.0
%endif

%files -n %{libubsan_name_orig}-devel
%{target_libdir}/libubsan.a
%{target_libdir}/libubsan.so
%if %isarch %{biarches}
%{_prefix}/lib/libubsan.a
%{_prefix}/lib/libubsan.so
%endif
%endif

%if %{build_libmpx}
%files -n %{libmpx_name}
%{target_libdir}/libmpx.so.%{libmpx_major}
%{target_libdir}/libmpx.so.%{libmpx_major}.0.%{libmpx_micro}
%{target_libdir}/libmpxwrappers.so.%{libmpx_major}
%{target_libdir}/libmpxwrappers.so.%{libmpx_major}.0.%{libmpx_micro}
%if %isarch %{biarches}
%{_prefix}/lib/libmpx.so.%{libmpx_major}
%{_prefix}/lib/libmpx.so.%{libmpx_major}.0.%{libmpx_micro}
%{_prefix}/lib/libmpxwrappers.so.%{libmpx_major}
%{_prefix}/lib/libmpxwrappers.so.%{libmpx_major}.0.%{libmpx_micro}
%endif

%files -n %{libmpx_name_orig}-devel
%{target_libdir}/libmpx.a
%{target_libdir}/libmpx.so
%{target_libdir}/libmpxwrappers.a
%{target_libdir}/libmpxwrappers.so
%{target_libdir}/libmpx.spec
%if %isarch %{biarches}
%{_prefix}/lib/libmpx.a
%{_prefix}/lib/libmpx.so
%{_prefix}/lib/libmpxwrappers.a
%{_prefix}/lib/libmpxwrappers.so
%{_prefix}/lib/libmpx.spec
%endif
%endif

%if %{build_libvtv}
%files -n %{libvtv_name}
%{target_libdir}/libvtv.so.%{libvtv_major}
%{target_libdir}/libvtv.so.%{libvtv_major}.0.0
%if %isarch %{biarches}
%{_prefix}/lib/libvtv.so.%{libvtv_major}
%{_prefix}/lib/libvtv.so.%{libvtv_major}.0.0
%endif

%files -n %{libvtv_name_orig}-devel
%{target_libdir}/libvtv.a
%{target_libdir}/libvtv.so
%if %isarch %{biarches}
%{_prefix}/lib/libvtv.a
%{_prefix}/lib/libvtv.so
%endif
%endif

%files cpp -f cpplib.lang
%{_mandir}/man1/%{program_prefix}cpp%{program_suffix}.1*
%if !%{build_cross} && %{system_compiler}
%{_prefix}/lib/%{cross_program_prefix}cpp
%endif
%ghost %{_bindir}/%{cross_program_prefix}cpp
%{_bindir}/%{program_prefix}cpp%{program_long_suffix}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/cc1

%if %{build_cxx}
%files c++ -f libstdc++.lang
%{_mandir}/man1/%{program_prefix}g++%{program_suffix}.1*
%ghost %{_bindir}/%{cross_program_prefix}c++
%{_bindir}/%{program_prefix}g++%{program_long_suffix}
%{_bindir}/%{program_prefix}c++%{program_long_suffix}
%{_bindir}/%{gcc_target_platform}-g++%{program_suffix}
%{_bindir}/%{gcc_target_platform}-c++%{program_suffix}
#
%{gcc_libdir}/%{gcc_target_platform}/%{version}/cc1plus
# symlinks to gcc3.4 stuff
%if !%{system_compiler}
#
%if %{build_stdcxxheaders}
%dir %{target_prefix}/include/c++
%{libstdcxx_includedir}
%endif
#
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/cxxabi.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/bits
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libstdc++.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libsupc++.a
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libstdc++.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libsupc++.a
%endif
%endif
%endif

%if %{build_libstdcxx} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libstdcxx_name}
%endif
%{target_libdir}/libstdc++.so.%{libstdcxx_major}
%{target_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}
%if %isarch %{biarches}
%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}
%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}
%endif
%if %isarch %{nof_arches}
%dir %{_libdir}/nof
%{_libdir}/nof/libstdc++.so.%{libstdcxx_major}
%{_libdir}/nof/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}
%endif
%endif

%if %{build_libstdcxx}
%if !%{build_monolithic}
%files -n %{libstdcxx_name_orig}-devel
%endif
%doc libstdc++-v3/README*
%dir %{libstdcxx_includedir}
%{libstdcxx_includedir}/*
%if !%build_cross
%{_datadir}/gdb/auto-load/%{_libdir}/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py*
%if %isarch %{biarches}
%{_datadir}/gdb/auto-load/%{_prefix}/lib/libstdc++.so.%{libstdcxx_major}.0.%{libstdcxx_micro}-gdb.py*
%endif
%endif
%dir %{py_puresitedir}/libstdcxx
%{py_puresitedir}/libstdcxx/__init__.py*
%dir %{py_puresitedir}/libstdcxx/v6
%{py_puresitedir}/libstdcxx/v6/__init__.py*
%{py_puresitedir}/libstdcxx/v6/printers.py*
%{py_puresitedir}/libstdcxx/v6/xmethods.py*

%if %{system_compiler}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/include
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/cxxabi.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/bits
%endif
#
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libsupc++.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libstdc++.so
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libsupc++.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libstdc++.so
%endif
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libsupc++.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libstdc++.so
%endif
%endif
%endif

%if %{build_libstdcxx}
%if !%{build_monolithic}
%files -n %{libstdcxx_name_orig}-static-devel
%endif
%doc libstdc++-v3/README
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libstdc++.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libstdc++fs.a
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libstdc++.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libstdc++fs.a
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libstdc++.a
%endif
%endif

# placement is important in order to avoid breaking build_monolithic case
%files -n %{name}-plugins
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/plugin/include/
%{gcc_libdir}/%{gcc_target_platform}/%{version}/plugin/include/*
%{gcc_libdir}/%{gcc_target_platform}/%{version}/plugin/gengtype
%{gcc_libdir}/%{gcc_target_platform}/%{version}/plugin/gtype.state
%{gcc_libdir}/%{gcc_target_platform}/%{version}/plugin/libcc1plugin.*

%if %{build_objc}
%files objc
%doc rpm.doc/objc/*
%{gcc_libdir}/%{gcc_target_platform}/%{version}/cc1obj
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libobjc.a
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libobjc_gc.a
%endif
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libobjc.so
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libobjc_gc.so
%endif
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libobjc.a
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libobjc_gc.a
%endif
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libobjc.so
%if %{build_objc_gc}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libobjc_gc.so
%endif
%endif
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libobjc.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libobjc_gc.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libobjc.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libobjc_gc.so
%endif
%endif
#
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/include/objc
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/objc/*.h
#
%endif

%if %{build_objc} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libobjc_name}
%endif
%doc rpm.doc/libobjc/*
%doc libobjc/THREADS* libobjc/ChangeLog
%{target_libdir}/libobjc.so.%{libobjc_major}
%{target_libdir}/libobjc.so.%{libobjc_major}.0.0
%if %{build_objc_gc}
%{target_libdir}/libobjc_gc.so.%{libobjc_major}
%{target_libdir}/libobjc_gc.so.%{libobjc_major}.0.0
%endif
%if %isarch %{biarches}
%{_prefix}/lib/libobjc.so.%{libobjc_major}
%{_prefix}/lib/libobjc.so.%{libobjc_major}.0.0
%if %{build_objc_gc}
%{_prefix}/lib/libobjc_gc.so.%{libobjc_major}
%{_prefix}/lib/libobjc_gc.so.%{libobjc_major}.0.0
%endif
%endif
%endif

%if %{build_objcp}
%files objc++
%doc rpm.doc/objcp/*
%{gcc_libdir}/%{gcc_target_platform}/%{version}/cc1objplus
%endif


%if %{build_fortran}
%files gfortran
%doc rpm.doc/gfortran/*
%{_mandir}/man1/%{program_prefix}gfortran%{program_suffix}.1*
%{_bindir}/%{program_prefix}gfortran%{program_suffix}
%{_bindir}/%{gcc_target_platform}-gfortran%{program_suffix}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/f951
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgfortran.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libcaf_single.la
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libcaf_single.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/finclude/ieee_arithmetic.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/finclude/ieee_exceptions.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/finclude/ieee_features.mod

%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/libgfortran.so
%endif
%if %isarch %{biarches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libgfortran.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libcaf_single.la
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libcaf_single.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/ieee_arithmetic.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/ieee_exceptions.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/ieee_features.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/omp_lib.f90
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/omp_lib.h
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/omp_lib.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/omp_lib_kinds.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/openacc.f90
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/openacc.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/openacc_kinds.mod
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/finclude/openacc_lib.h
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/32/libgfortran.so
%endif
%endif
%if %isarch %{nof_arches}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libgfortran.a
%if %{libc_shared}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/nof/libgfortran.so
%endif
%endif
%if %{build_libgomp}
%{gcc_libdir}/%{gcc_target_platform}/%{version}/finclude/omp*
%{gcc_libdir}/%{gcc_target_platform}/%{version}/finclude/openacc*
%endif
%endif

%if %{build_fortran} && %{libc_shared}
%if !%{build_monolithic}
%files -n %{libgfortran_name}
%endif
%{target_libdir}/libgfortran.so.%{libgfortran_major}
%{target_libdir}/libgfortran.so.%{libgfortran_major}.0.0
%{target_libdir}/libgfortran.spec
%if %isarch %{biarches}
%{_prefix}/lib/libgfortran.so.%{libgfortran_major}
%{_prefix}/lib/libgfortran.so.%{libgfortran_major}.0.0
%{_prefix}/lib/libgfortran.spec
%endif
%endif

%if %{build_ada}
%files gnat
%{_bindir}/gnat*
%{gcc_libdir}/%{gcc_target_platform}/%{version}/gnat1
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/adainclude
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adainclude/*.adb
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adainclude/*.ads
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/*.ali
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgmem.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnat.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnat_pic.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnarl.a
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnarl_pic.a
%if %{libc_shared}
%{_libdir}/libgnat-%{libgnat_major}.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnat.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnat-%{libgnat_major}.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnarl.so
%{gcc_libdir}/%{gcc_target_platform}/%{version}/adalib/libgnarl-%{libgnat_major}.so
%endif
%endif

%if %{build_libffi}
%files -n %{libffi_name}
%{target_libdir}/libffi.so.%{libffi_major}
%{target_libdir}/libffi.so.%{libffi_major}.0.1
%if %isarch %{biarches}
%{_prefix}/lib/libffi.so.%{libffi_major}
%{_prefix}/lib/libffi.so.%{libffi_major}.0.1
%endif

%files -n %{libffi_name}-devel
%doc libffi/README libffi/LICENSE libffi/ChangeLog*
%{_mandir}/man3/ffi*.3*
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}
%dir %{gcc_libdir}/%{gcc_target_platform}/%{version}/include
%{gcc_libdir}/%{gcc_target_platform}/%{version}/include/ffi*.h
%{_libdir}/libffi.a
%{_libdir}/libffi.so
%if %isarch %{biarches}
%{_prefix}/lib/libffi.a
%{_prefix}/lib/libffi.so
%endif
%endif

%if %{build_ada} && %{libc_shared}
%files -n %{libgnat_name}
%{target_libdir}/libgnat-%{libgnat_major}.so
%{target_libdir}/libgnarl-%{libgnat_major}.so
%endif

%if %{build_doc}
%files doc
%doc gcc/*ChangeLog*
%if %{build_check}
%doc test_summary.log
%endif
%{_infodir}/cppinternals%{_package_suffix}.info*
%{_infodir}/cpp%{_package_suffix}.info*
%{_infodir}/gcc%{_package_suffix}.info*
%{_infodir}/gccinstall%{_package_suffix}.info*
%{_infodir}/gccint%{_package_suffix}.info*
%if %{build_libstdcxx}
%doc rpm.doc/libstdc++/
%endif
%if %{build_cxx}
%doc rpm.doc/c++
%endif
%if %{build_libgomp}
%{_infodir}/libgomp%{_package_suffix}.info*
%endif
%if %{build_ada}
%{_infodir}/gnat-style%{_package_suffix}.info*
%{_infodir}/gnat_rm%{_package_suffix}.info*
%{_infodir}/gnat_ugn%{_package_suffix}.info*
%endif
%if %{build_fortran}
%{_infodir}/gfortran%{_package_suffix}.info*
%endif
%if %{build_quadmath}
%{_infodir}/libquadmath%{_package_suffix}.info*
%endif
%if %{build_libitm}
%{_infodir}/libitm%{_package_suffix}.info*
%endif
%endif

%if %{build_pdf_doc}
%files doc-pdf
%doc gcc/doc/cppinternals.pdf
%doc gcc/doc/gcc.pdf
%doc gcc/doc/cpp.pdf
%if %{build_ada}
%doc gcc/ada/gnat_rm.pdf
%doc gcc/ada/gnat_ugn.pdf
%endif
%if %{build_fortran}
%doc gcc/fortran/gfortran.pdf
%endif
%endif

%if %{build_libstdcxx_docs}
%files -n libstdc++-docs
%{_mandir}/man3/*
%doc rpm.doc/libstdc++-v3/html
%endif


%changelog
* Wed Mar 04 2020 tmb <tmb> 8.4.0-1.mga7
+ Revision: 1553624
- PR lto/93966: Also copy .note.gnu.property section
- update to 8.4.0 final
- update to second RC
- update to 8.4.0 RC
- PR c++/86521 - C++17 copy elision in initialization by constructor.
- update to 8.3.1 snapshot 20200221
- update to 8.3.1 snapshot 20200131
- PR target/86487: lra-constraints.c(uses_hard_regs_p): Fix handling of
  paradoxical SUBREGS.
- update to 8.3.1 snapshot 20191101
- obsolete libgfortran3, libasan2, libubsan0, libgnat1 for clean upgrade from mga6
- obsolete gcj, cilk and vtv as they are gone from gcc 8
- update to 8.3.1 snapshot 20191025
- update to 8.3.1 snapshot 20190920
- update to 8.3.1 snapshot 20190913
- update to 8.3.1 snapshot 20190802
- PR rtl-optimization/90756: explow.c (promote_ssa_mode): Always use
  TYPE_MODE, don't bypass it for VECTOR_TYPE_P
- PR middle-end/90139 : tree-outof-ssa.c,  (get_temp_reg): If reg_mode
  is BLKmode, return assign_temp instead of gen_reg_rtx.

* Sat May 25 2019 tmb <tmb> 8.3.1-0.20190524.1.mga7
+ Revision: 1399083
- update to 8.3.1 snapshot 20190524

* Sat May 18 2019 tmb <tmb> 8.3.1-0.20190517.1.mga7
+ Revision: 1398259
- update to 8.3.1 snapshot 20190517

* Sat May 11 2019 tmb <tmb> 8.3.1-0.20190510.1.mga7
+ Revision: 1397191
- update to 8.3.1 snapshot 20190510

* Sat May 04 2019 tmb <tmb> 8.3.1-0.20190503.1.mga7
+ Revision: 1396328
- update to 8.3.1 snapshot 2019-05-03

* Sat Apr 20 2019 tmb <tmb> 8.3.1-0.20190419.2.mga7
+ Revision: 1394141
- rebuild for arm

* Sat Apr 20 2019 tmb <tmb> 8.3.1-0.20190419.1.mga7
+ Revision: 1394046
- update to 8.3.1 snapshot 2019-04-19

* Sat Apr 13 2019 tmb <tmb> 8.3.1-0.20190412.1.mga7
+ Revision: 1389667
- update to 8.3.1 snapshoy 2019-04-12

* Sat Apr 06 2019 tmb <tmb> 8.3.1-0.20190405.1.mga7
+ Revision: 1386351
- update to 8.3.1 snapshot 2019-04-05

* Sat Mar 30 2019 tmb <tmb> 8.3.1-0.20190329.1.mga7
+ Revision: 1381447
- update to 8.3.1 snapshot 2019-03-29

* Sat Mar 23 2019 tmb <tmb> 8.3.1-0.20190322.1.mga7
+ Revision: 1379711
- update to 8.3.1 snapshot 2019-03-22

* Fri Mar 15 2019 tmb <tmb> 8.3.1-0.20190315.1.mga7
+ Revision: 1377756
- update to 8.3.1 snapshot 2019-03-15

* Tue Mar 12 2019 tmb <tmb> 8.3.1-0.20190308.1.mga7
+ Revision: 1374655
- add more fixes from upstream gcc-8 branch
- update to 8.3.1 snapshot 2019-03-08

* Fri Mar 01 2019 tmb <tmb> 8.3.0-5.mga7
+ Revision: 1370755
- AArch64: Make every option in options.def one line (GCC-8)

* Wed Feb 27 2019 tmb <tmb> 8.3.0-4.mga7
+ Revision: 1370385
- PR target/89397: config/i386/i386.c:  Check TARGET_SSE in addition
  to TARGET_SSE_MATH.

* Tue Feb 26 2019 tmb <tmb> 8.3.0-3.mga7
+ Revision: 1370289
- PR c++/89212 - ICE converting nullptr to pointer-to-member-function

* Sat Feb 23 2019 tmb <tmb> 8.3.0-2.mga7
+ Revision: 1369579
- PR libstdc++/89446: fix null pointer dereference in char_traits

* Fri Feb 22 2019 tmb <tmb> 8.3.0-1.mga7
+ Revision: 1369362
- update to 8.3.0 final

* Fri Feb 15 2019 tmb <tmb> 8.3.0-0.RC.1.mga7
+ Revision: 1367461
- update to 8.3.0-RC

* Sat Feb 09 2019 tmb <tmb> 8.2.1-0.20190208.1.mga7
+ Revision: 1364364
- drop asm backport revert
- update to 8.2.1 snapshot 2019-02-08

* Thu Feb 07 2019 tmb <tmb> 8.2.1-0.20190201.2.mga7
+ Revision: 1363908
- rebuild with new binutils

* Sat Feb 02 2019 tmb <tmb> 8.2.1-0.20190201.1.mga7
+ Revision: 1362321
- update to 8.2.1 snapshot 2019-02-01

* Tue Jan 22 2019 luigiwalser <luigiwalser> 8.2.1-0.20190118.2.mga7
+ Revision: 1359163
- rebuild for isl

* Sat Jan 19 2019 tmb <tmb> 8.2.1-0.20190118.1.mga7
+ Revision: 1358004
- update to 8.2.1 snapshot 2019-01-18

* Sun Jan 13 2019 tmb <tmb> 8.2.1-0.20190111.1.mga7
+ Revision: 1355908
- rebase asm revert
- update to 8.2.1 snapshot 2019-01-11

* Tue Jan 08 2019 tmb <tmb> 8.2.1-0.20190104.2.mga7
+ Revision: 1352696
- revert upstream 'Backport of the "asm inline" patches' for now as it
  breaks atleast virtualbox builds

* Sat Jan 05 2019 tmb <tmb> 8.2.1-0.20190104.1.mga7
+ Revision: 1349902
- update to 8.2.1 snapshot 2019-01-04

* Sat Dec 29 2018 tmb <tmb> 8.2.1-0.20181228.1.mga7
+ Revision: 1346228
- update to gcc 8.2.1 snapshot 2018-12-28

* Sat Dec 22 2018 tmb <tmb> 8.2.1-0.20181221.1.mga7
+ Revision: 1344348
- update to 8.2.1 snapshot 2018-12-21

* Sat Dec 15 2018 tmb <tmb> 8.2.1-0.20181214.1.mga7
+ Revision: 1341404
- update to gcc 8.2.1 snapshot 2018-12-14

* Fri Dec 07 2018 tmb <tmb> 8.2.1-0.20181207.1.mga7
+ Revision: 1338862
- update to 8.2.1 snapshot 2018-12-07

* Fri Nov 30 2018 tmb <tmb> 8.2.1-0.20181130.1.mga7
+ Revision: 1336970
- update to 8.2.1 snapshot 2018-11-30

* Sat Nov 24 2018 tmb <tmb> 8.2.1-0.20181123.1.mga7
+ Revision: 1333699
- update to 8.2.1 snapshot 2018-11-23

* Thu Nov 22 2018 tmb <tmb> 8.2.1-0.20181116.2.mga7
+ Revision: 1333306
- PR target/87928: config/i386/i386.h (STACK_BOUNDARY): Use TARGET_64BIT_MS_ABI
- PR gcov-profile/88045: workaround call to std::accumulate causes gcov to crash
- PR rtl-optimization/85925: compilation of masking goes wrong in combine at -02
- PR lto/88077: ICE: tree check: expected class ‘type’, have ‘declaration’

* Sat Nov 17 2018 tmb <tmb> 8.2.1-0.20181116.1.mga7
+ Revision: 1330290
- update to 8.2.1 snapshot 2018-11-16

* Sat Nov 10 2018 tmb <tmb> 8.2.1-0.20181109.1.mga7
+ Revision: 1329245
- update to 8.2.1 snapshot 2018-11-09

* Sat Nov 03 2018 tmb <tmb> 8.2.1-0.20181102.1.mga7
+ Revision: 1327987
- update to 8.2.1 snapshot 2018-11-02

* Sat Oct 27 2018 tmb <tmb> 8.2.1-0.20181026.1.mga7
+ Revision: 1326153
- update to 8.2.1 snapshot 2018-10-26

* Sat Oct 20 2018 tmb <tmb> 8.2.1-0.20181019.1.mga7
+ Revision: 1322931
- update to 8.2.1 snapshot 20181019

* Sat Oct 13 2018 tmb <tmb> 8.2.1-0.20181012.1.mga7
+ Revision: 1320043
- update to 8.2.1 snapshot 20181012

* Sat Oct 06 2018 tmb <tmb> 8.2.1-0.20181005.1.mga7
+ Revision: 1318087
- update to 8.2.1 snapshot 2018-10-05

* Sat Sep 29 2018 tmb <tmb> 8.2.1-0.20180928.1.mga7
+ Revision: 1311643
- update to 8.2.1 snapshot 20180928

* Sat Sep 22 2018 tmb <tmb> 8.2.1-0.20180921.1.mga7
+ Revision: 1296579
- update to 8.2.1 snapshot 20180921

* Sat Sep 15 2018 tmb <tmb> 8.2.1-0.20180914.1.mga7
+ Revision: 1258980
- update to 8.2.1 snapshot 20180914

* Tue Sep 11 2018 tmb <tmb> 8.2.1-0.20180907.2.mga7
+ Revision: 1258414
- PR libstdc++/87278 restore support for std::make_shared<volatile T>()

* Sat Sep 08 2018 tmb <tmb> 8.2.1-0.20180907.1.mga7
+ Revision: 1257744
- update to 8.2.1 snapshot 20180907
+ tv <tv>
- rely on filetriggers for info system (mga#23482)

* Sat Sep 01 2018 tmb <tmb> 8.2.1-0.20180831.2.mga7
+ Revision: 1256056
- update to 8.2.1 snapshot 20180831

* Tue Aug 28 2018 tmb <tmb> 8.2.1-0.20180824.2.mga7
+ Revision: 1255249
- PR target/86662: msp430-elf segfault with -flto and -mlarge
- PR libfortran/86704: Segmentation fault when using matmul in combination with transpose
- PR rtl-optimization/87065: combine causes ICE in trunc_int_for_mode

* Sat Aug 25 2018 tmb <tmb> 8.2.1-0.20180824.1.mga7
+ Revision: 1253906
- update to 8.2.1 - 20180824 snapshot

* Sat Aug 18 2018 tmb <tmb> 8.2.1-0.20180817.1.mga7
+ Revision: 1252391
- update to 8.2.1 snapshot 20180817

* Sat Aug 11 2018 tmb <tmb> 8.2.1-0.20180810.2.mga7
+ Revision: 1251096
- PR c++/86728 - C variadic generic lambda

* Sat Aug 11 2018 tmb <tmb> 8.2.1-0.20180810.1.mga7
+ Revision: 1250986
- update to 8.2.1 snapshot 2018-08-10

* Sat Aug 04 2018 tmb <tmb> 8.2.1-0.20180803.1.mga7
+ Revision: 1247200
- update to 8.2.1 snapshot 2018-08-03

* Thu Aug 02 2018 tv <tv> 8.2.1-0.20180727.3.mga7
+ Revision: 1246921
- further fix upgrade

* Thu Aug 02 2018 tv <tv> 8.2.1-0.20180727.2.mga7
+ Revision: 1246852
- fix upgrade

* Sat Jul 28 2018 tmb <tmb> 8.2.1-0.20180727.1.mga7
+ Revision: 1245664
- update to 8.2.1 snapshot 20180727
- drop some obsolete manbo stuff
- fix url and source url
- Obsolete libcilkrts packages

* Fri Jul 27 2018 tmb <tmb> 8.2.0-0.5.mga7
+ Revision: 1245541
- update filelists
- libgnat major is now 8
- drop old Ada Makefile hack
- libstdc++ micro is now 25
- libgfortran major is now 5
- libasan major is now 5
- libubsan major is now 1
- fix typos
- Cilk+ is removed upstream
- drop unused mips stuff
- drom ancient lsb hacks
- rebase and reorder mageia patches
- pass --with-linker-hash-style=gnu to build instead of patching it
- rebase linux32 patch
- drop merged / obsolete patches
- update to 8.2.0

* Tue Jul 24 2018 tmb <tmb> 7.3.0-8.mga7
+ Revision: 1245050
- rebuild with binutils 2.31.1-2.mga7

* Sat Jul 21 2018 tmb <tmb> 7.3.0-6.mga7
+ Revision: 1244751
- testbuild with new binutils

* Sat May 26 2018 tmb <tmb> 7.3.0-5.mga7
+ Revision: 1232301
- rebuild with new optflags
- rebuild with new glibc
+ wally <wally>
- add aarch64 support
- add a patch from Fedora to always emit DWARF-2 unwind info on aarch64

* Tue Feb 20 2018 tmb <tmb> 7.3.0-3.mga7
+ Revision: 1203499
- backport PR C++/80654: Implement new C++ intrinsics __is_assignable
  and __is_constructible. (requested on dev@ by Christiaan Welvaart)

* Mon Feb 19 2018 kekepower <kekepower> 7.3.0-2.mga7
+ Revision: 1202945
- Rebuild for new mpfr

* Thu Jan 25 2018 tmb <tmb> 7.3.0-1.mga7
+ Revision: 1197178
- update to 7.3.0 final

* Mon Jan 22 2018 tmb <tmb> 7.3.0-0.rc.20180122.1.mga7
+ Revision: 1196301
- update to 7.3.0 rc2

* Thu Jan 18 2018 tmb <tmb> 7.3.0-0.rc.20180117.1.mga7
+ Revision: 1194281
- update to 7.3.0 RC

* Sat Dec 23 2017 tmb <tmb> 7.2.2-20171221.1.mga7
+ Revision: 1184244
- update to 20171221 snapshot

* Fri Dec 08 2017 tmb <tmb> 7.2.2-20171207.1.mga7
+ Revision: 1181736
- update to 2017-12-07 snapshot

* Mon Dec 04 2017 tmb <tmb> 7.2.2-20171130.1.mga7
+ Revision: 1181243
- rebuild against re-bootstrapped gcc
- try to disable bootstrap
- update to 2017-11-30 snapshot
- updat to 2017-11-02 snapshot
- update to 20170709 snapshot

* Fri Sep 01 2017 tmb <tmb> 7.2.1-20170831.1.mga7
+ Revision: 1150374
- rebuild with binutils-2.29.0-5.mga7
- update to 20180831 snapshot

* Sun Aug 27 2017 tmb <tmb> 7.2.1-1.mga7
+ Revision: 1148281
- update to 7.2.1 snapshot 2017-08-24
- rebuild with new binutils
- update to 7.2.0 final
- update filelist for arm

* Sun Aug 13 2017 tmb <tmb> 7.2.0-0.RC.1.mga7
+ Revision: 1140050
- force build with new binutils 2.29
- update filelists and devel provides for libgcc_s
- temporaily disable libvtv
- update filelists
- drop obsolete revert
- fix missing endif
- BR gcc-c++ as its mandatory to build gcc
- ensure BASE-VER always matches rpm version
- add libmpx packages
- libgfortran major is now 4
- libasan major is now 4
- libatomic minor is now 2
- rebase ada makefile fix
- update to second RC
- drop obsolete patches
- spec cleanups
- rebase P107 (pass libdir around)
- rebase P115 (linux32 suport), P211 (hash-style gnu)
- allow disabling of objc-gc
- libstdcxx micro is now 24
- bye-bye gpc
- bye-bye java
- update to 7.2 RC

* Sat Jul 01 2017 tmb <tmb> 5.4.0-5.mga6
+ Revision: 1108810
- add Mageia branding (requested by Remi on dev@ ml)

* Sat May 13 2017 tmb <tmb> 5.4.0-4.mga6
+ Revision: 1100979
- more miscompilation and ICE fixes from upstream gcc-5 branch

* Wed Apr 26 2017 tmb <tmb> 5.4.0-3.mga6
+ Revision: 1097540
- more fixes from upstream gcc-5 branch

* Sun Mar 26 2017 tmb <tmb> 5.4.0-2.mga6
+ Revision: 1094890
- add regression, miscompilation and ICE fixes from upstream gcc-5 branch
- Support exception propagation without lock-free atomic int

* Fri Jun 03 2016 tmb <tmb> 5.4.0-1.mga6
+ Revision: 1020173
- update to 5.4.0 final

* Sun May 29 2016 tmb <tmb> 5.4.0-0.RC.1.mga6
+ Revision: 1019344
- update to 5.4.0-RC
+ tv <tv>
- fix error on uninstalling gcc-doc

* Thu May 05 2016 tmb <tmb> 5.3.1-0.20160503.1.mga6
+ Revision: 1009624
- update to 2016-05-03 snapshot

* Wed Apr 20 2016 tmb <tmb> 5.3.1-0.20160419.1.mga6
+ Revision: 1003817
- update to 2016-04-19
+ pterjan <pterjan>
- Add flags for armv7hl

* Wed Apr 06 2016 tmb <tmb> 5.3.1-0.20160405.1.mga6
+ Revision: 999024
- update to 2016-04-05

* Thu Mar 24 2016 tmb <tmb> 5.3.1-0.20160322.1.mga6
+ Revision: 994763
- update to 2016-03-22

* Thu Mar 17 2016 tmb <tmb> 5.3.1-0.20160315.2.mga6
+ Revision: 992428
- fix PR c++/70209: ICE in strip_typedefs (mga#17949)

* Wed Mar 16 2016 tmb <tmb> 5.3.1-0.20160315.1.mga6
+ Revision: 992202
- update to 2016-03-15 snapshot

* Tue Mar 15 2016 tmb <tmb> 5.3.1-0.20160308.1.mga6
+ Revision: 991066
- update to 2016-03-08 snapshot

* Mon Mar 07 2016 cjw <cjw> 5.3.1-0.20160301.3.mga6
+ Revision: 986986
- fix dependency on libecj-java since this provides was dropped from ecj
- make libatomic-devel depend on libatomic

* Sun Mar 06 2016 pterjan <pterjan> 5.3.1-0.20160301.2.mga6
+ Revision: 986561
- Enable ada on arm

* Thu Mar 03 2016 tmb <tmb> 5.3.1-0.20160301.1.mga6
+ Revision: 984393
- update to 2016-03-01
+ neoclust <neoclust>
- Enable java on arm

* Fri Feb 26 2016 tmb <tmb> 5.3.1-0.20160223.1.mga6
+ Revision: 979672
- update to 2016-02-23

* Thu Jan 28 2016 tmb <tmb> 5.3.1-0.20160126.1.mga6
+ Revision: 928448
- update to 2015-01-26 snapshot

* Sun Jan 24 2016 luigiwalser <luigiwalser> 5.3.1-0.20160112.3.mga6
+ Revision: 926994
- rebuild for real this time

* Sun Jan 24 2016 luigiwalser <luigiwalser> 5.3.1-0.20160112.2.mga6
+ Revision: 926937
- rebuild for isl

* Wed Jan 13 2016 tmb <tmb> 5.3.1-0.20160112.1.mga6
+ Revision: 922843
- update to 2016-01-12

* Wed Jan 06 2016 tmb <tmb> 5.3.1-0.20160105.1.mga6
+ Revision: 919920
- update to 2016-01-05 snapshot

* Wed Dec 23 2015 tmb <tmb> 5.3.1-0.20151222.1.mga6
+ Revision: 913712
- update to 5.3.1 snapshot 2015-12-22

* Sun Dec 06 2015 tmb <tmb> 5.3.0-2.mga6
+ Revision: 908488
- fix PR lto/(65948/66027): ICE in odr_types_equivalent_p
- fix PR c++/67337: segfault in mangle.c

* Fri Dec 04 2015 tmb <tmb> 5.3.0-1.mga6
+ Revision: 908104
- update to 5.3.0 final

* Sun Nov 29 2015 tmb <tmb> 5.2.1-0.20151124.1.mga6
+ Revision: 907029
- update to 2015-11-24

* Wed Nov 11 2015 tmb <tmb> 5.2.1-0.20151110.1.mga6
+ Revision: 901570
- update to 2015-11-10 snapshot

* Wed Nov 04 2015 tmb <tmb> 5.2.1-0.20151103.1.mga6
+ Revision: 897831
- update to 2015-11-03

* Wed Oct 21 2015 tmb <tmb> 5.2.1-0.20151020.1.mga6
+ Revision: 894012
- update to 2015-10-20 snapshot

* Wed Oct 14 2015 tmb <tmb> 5.2.1-0.20151013.1.mga6
+ Revision: 890766
- update to 2015-10-13 snapshot

* Wed Sep 23 2015 tmb <tmb> 5.2.1-0.20150922.1.mga6
+ Revision: 882437
- update to 2015-09-22 snapshot

* Tue Sep 08 2015 blino <blino> 5.2.1-0.20150811.6.mga6
+ Revision: 874027
- package arm_acle.h on ARM
- package stdalign/stdatomic/stdnoreturn headers for all archs (stdatomic was not included on ARM)
- package openacc.h in gomp devel package, and not only for x86 (built on ARM as well)
- package libcc1.so for ARM as well
- build vtv only on i?86 and x86_64, unsupported otherwise (e.g. on ARM)

* Mon Sep 07 2015 blino <blino> 5.2.1-0.20150811.5.mga6
+ Revision: 873840
- fix prep without java (for arm/mips)

* Mon Aug 24 2015 blino <blino> 5.2.1-0.20150811.4.mga6
+ Revision: 869029
- remove incorrect obsoletes/provides for libstdc++5

* Thu Aug 20 2015 tmb <tmb> 5.2.1-0.20150811.3.mga6
+ Revision: 866934
- submit to /release

* Thu Aug 20 2015 tmb <tmb> 5.2.1-0.20150811.2.mga6
+ Revision: 866038
- cloog and ppl has been replaced by isl for Graphite support

* Wed Aug 19 2015 tmb <tmb> 5.2.1-0.20150811.1.mga6
+ Revision: 866002
- update to 5.2.1 snapshot 2015-08-11
  * see: https://gcc.gnu.org/gcc-5/changes.html
  * libstdcxx micro is now 21
  * libgcj major is now 16
  * libasan major is now 2
  * disable broken pdf build
  * update filelists

* Tue Aug 18 2015 tmb <tmb> 4.9.2-8.mga6
+ Revision: 865414
- rebuild with fixed glibc
- rebuild with new glibc

* Sun Aug 02 2015 tmb <tmb> 4.9.2-6.mga6
+ Revision: 860856
- rebuild with new binutils

* Fri Jul 31 2015 tmb <tmb> 4.9.2-5.mga6
+ Revision: 860179
- testbuild with new binutils

* Sun Nov 02 2014 cjw <cjw> 4.9.2-4.mga5
+ Revision: 795243
- source9/patch133: add java.security classes from apache harmony to libgcj to fix networking with bouncycastle 1.50

* Thu Oct 30 2014 tmb <tmb> 4.9.2-3.mga5
+ Revision: 794707
- update to 4.9.2 final

* Fri Oct 24 2014 tmb <tmb> 4.9.2-1.RC.2.mga5
+ Revision: 792983
- lsan is only available on x86_64
- update filelists
- update to 4.9.2-RC

* Wed Oct 15 2014 umeabot <umeabot> 4.9.2-0.20141001.2.mga5
+ Revision: 747981
- Second Mageia 5 Mass Rebuild

* Fri Oct 03 2014 tmb <tmb> 4.9.2-0.20141001.1.mga5
+ Revision: 736459
- update to 2014-10-01
- update to 2014-10-01

* Thu Sep 25 2014 tmb <tmb> 4.9.2-0.20140924.1.mga5
+ Revision: 724531
- update to 2014-09-24 snapshot

* Sat Sep 20 2014 tmb <tmb> 4.9.2-0.20140910.3.mga5
+ Revision: 697479
- rebuild with fixed rpm-mageia-setup

* Tue Sep 16 2014 umeabot <umeabot> 4.9.2-0.20140910.2.mga5
+ Revision: 679433
- Mageia 5 Mass Rebuild

* Thu Sep 11 2014 tmb <tmb> 4.9.2-0.20140910.1.mga5
+ Revision: 674668
- update to 2014-09-10

* Tue Sep 09 2014 tmb <tmb> 4.9.2-0.20140903.2.mga5
+ Revision: 674222
- rebuild with new glibc

* Thu Sep 04 2014 tmb <tmb> 4.9.2-0.20140903.1.mga5
+ Revision: 672114
- update to 2014-09-03

* Thu Aug 28 2014 tmb <tmb> 4.9.2-0.20140827.1.mga5
+ Revision: 669062
- update to 2014-08-27 snapshot

* Mon Aug 25 2014 tmb <tmb> 4.9.2-0.20140820.1.mga5
+ Revision: 667297
- update to 2014-08-20 snapshot

* Sat Aug 09 2014 tv <tv> 4.9.2-0.20140730.3.mga5
+ Revision: 661306
- make lib*san-devel requires lib*san1

* Sat Aug 09 2014 tv <tv> 4.9.2-0.20140730.2.mga5
+ Revision: 661283
- make libasan-devel requires libasan1

* Thu Jul 31 2014 tmb <tmb> 4.9.2-0.20140730.1.mga5
+ Revision: 658546
- update to 4.9.2 snapshot 2014-07-30 (CVE-2014-5044)

* Sun Jul 27 2014 tmb <tmb> 4.9.1-2.mga5
+ Revision: 657566
- gcc/PR61801: fix sched2 miscompiles syscall sequence

* Thu Jul 17 2014 tv <tv> 4.9.1-1.mga5
+ Revision: 653378
- new release

* Thu Jul 03 2014 tmb <tmb> 4.9.1-0.20140702.1.mga5
+ Revision: 642672
- update to 20140702 snapshot

* Tue Jul 01 2014 tmb <tmb> 4.9.1-0.20140625.2.mga5
+ Revision: 641812
- ship cxxabi.h and cxxabi_tweaks.h in both upstream default path for clang
  to work and Mageia specific path to keep backward compatibility (mga#13543)

* Thu Jun 26 2014 tmb <tmb> 4.9.1-0.20140625.1.mga5
+ Revision: 639753
- update to 20140625 snapshot

* Thu Jun 19 2014 tmb <tmb> 4.9.1-0.20140618.1.mga5
+ Revision: 638133
- update to 20140618 snapshot

* Thu Jun 12 2014 tmb <tmb> 4.9.1-0.20140611.1.mga5
+ Revision: 635741
- update to 20140611 snapshot

* Thu Jun 05 2014 tmb <tmb> 4.9.1-0.20140604.1.mga5
+ Revision: 633483
- update to 2014-06-04 snapshot

* Sat May 31 2014 pterjan <pterjan> 4.9.1-0.20140528.2.mga5
+ Revision: 628208
- Rebuild for new Python

* Thu May 29 2014 tmb <tmb> 4.9.1-0.20140528.1.mga5
+ Revision: 627475
- update to 20140528 snapshot

* Thu May 22 2014 tmb <tmb> 4.9.1-0.20140521.1.mga5
+ Revision: 624927
- update to 20140521 snapshot

* Fri May 16 2014 tmb <tmb> 4.9.1-0.20140514.1.mga5
+ Revision: 622989
- update to 20140514 snapshot

* Tue May 13 2014 tmb <tmb> 4.9.1-0.20140507.2.mga5
+ Revision: 622491
- push to release

* Thu May 08 2014 tmb <tmb> 4.9.1-0.20140507.1.mga5
+ Revision: 621215
- update to 20140507 snapshot

* Wed May 07 2014 tmb <tmb> 4.9.1-0.20140430.3.mga5
+ Revision: 621039
- switch to 4.9.1 snapshot 20140430
- fix libgcj pkconfig file
- adjust build defines
- revert PR bootstrap/56714 as it breaks the build
- drop p120 (merged), p125 (fixed)
- update filelists
- libatomic minor is now 1
- libgcj major is now 15
- libasan major is now 1
- libstdc++ micro version is now 20
- add new package definitions:
  * liblsan: Leak Sanitizer Libraries
  * libubsan: Undefined Behaviour Sanitizer Libraries
  * libvtv: Virtual Table Verification Libraries
  * libcilkrts: Cilk+ Runtime Libraries
- mudflap run time checker has been removed
- update to 4.9.0

* Mon Feb 17 2014 tmb <tmb> 4.8.2-5.mga5
+ Revision: 593942
- rebuild with new glibc

* Sat Feb 08 2014 tmb <tmb> 4.8.2-4.mga5
+ Revision: 586837
- adapt for new freetype2 include path (P125)
- test build with new glibc

* Wed Oct 23 2013 tmb <tmb> 4.8.2-3.mga4
+ Revision: 546668
- fix bug in nth_element (PR libstdc++/58800, mga #11516)

* Tue Oct 22 2013 umeabot <umeabot> 4.8.2-2.mga4
+ Revision: 545598
- Mageia 4 Mass Rebuild

* Wed Oct 16 2013 tmb <tmb> 4.8.2-1.mga4
+ Revision: 501462
- update to 4.8.2 final

* Sat Oct 12 2013 tmb <tmb> 4.8.2-0.20131009.2.mga4
+ Revision: 496063
- rebuild with new binutils & make

* Fri Oct 11 2013 tmb <tmb> 4.8.2-0.20131009.1.mga4
+ Revision: 495122
- update to 4.8.2 RC

* Fri Oct 04 2013 tmb <tmb> 4.8.2-0.20131003.1.mga4
+ Revision: 491582
- update filelists
- update to 2013-10-03

* Sun Sep 22 2013 tmb <tmb> 4.8.2-0.20130919.1.mga4
+ Revision: 483258
- update to 2013-09-19

* Tue Sep 17 2013 tmb <tmb> 4.8.2-0.20130912.1.mga4
+ Revision: 480784
- update to 2013-09-12

* Tue Sep 10 2013 tmb <tmb> 4.8.2-0.20130905.1.mga4
+ Revision: 477216
- update to 2013-09-05

* Sat Aug 24 2013 tmb <tmb> 4.8.2-0.20130822.1.mga4
+ Revision: 471381
- update to 2013-08-22 snapshot

* Sun Aug 18 2013 tmb <tmb> 4.8.2-0.20130815.1.mga4
+ Revision: 467526
- update to 2013-08-15 snapshot

* Sun Aug 11 2013 tmb <tmb> 4.8.2-0.20130808.2.mga4
+ Revision: 465377
- push to /release

* Fri Aug 09 2013 tmb <tmb> 4.8.2-0.20130808.1.mga4
+ Revision: 465008
- update to 2013-08-08

* Sat Aug 03 2013 tmb <tmb> 4.8.2-0.20130801.1.mga4
+ Revision: 463026
- update to 2013-08-01 snapshot
- force binutils 2.23.2 (build)requires

* Thu Aug 01 2013 tmb <tmb> 4.8.2-0.20130725.1.mga4
+ Revision: 461959
- update filelists
- add libatomic, libasan and libtsan (and their devel) subpackages
- libstdc++ minor is now 18
- libgcj major is now 14
- rediff gnuhash patches
- drop 'PR tree-optimization/33763' fix (merged)
- rediff linux32 patch
- drop merged patches
- update to 4.8.2 (20130725 pre-release)

* Sat May 04 2013 anssi <anssi> 4.7.2-7.mga3
+ Revision: 412285
- fix /usr/lib/cpp target (cosmetic, not seen due to alternatives)
- add conflicts against old gcc3.3-cpp for smooth upgrade

* Fri Jan 11 2013 umeabot <umeabot> 4.7.2-6.mga3
+ Revision: 351094
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 01 2013 tmb <tmb> 4.7.2-5.mga3
+ Revision: 337399
- rebuild for new glibc

* Wed Oct 24 2012 blino <blino> 4.7.2-4.mga3
+ Revision: 309834
- remove ar/ranlib hack now that a fixed gcc-ar is available

* Wed Oct 24 2012 blino <blino> 4.7.2-3.mga3
+ Revision: 309752
- build temporarily with AR=ar and RANLIB=ranlib to workaround broken i586-mageia-linux-gnu-ar/ranlib
- fix gcc-ar exit code (from upstream git, to fix gcc build)
- fix inlining failure with fpmath=sse pragma (gcc#54988)

* Sun Oct 07 2012 tmb <tmb> 4.7.2-2.mga3
+ Revision: 303207
- fix gcc-ar, gcc-nm and gcc-ranlib target_platform specific symlinks
  (reported by Liutauras Adomaitis on -dev ml, and in mga #7393)
- make gcc-ar, gcc-nm, and gcc-ranlib use update-alternatives like gcc

* Sun Sep 23 2012 tmb <tmb> 4.7.2-1.mga3
+ Revision: 296791
- drop patches P108, P220-P223 (merged upstream)
- update to 4.7.2

* Sun Jul 29 2012 guillomovitch <guillomovitch> 4.7.1-7.mga3
+ Revision: 275547
- drop gnatmake completion, a more uptodate one is available in bash-completion package
- fix /lib/cpp link broken by /usr move

* Fri Jul 20 2012 tmb <tmb> 4.7.1-6.mga3
+ Revision: 272720
- PR 52908 - xop-mul-1:f9 miscompiled on bulldozer (-mxop) (P220)
- PR debug/53682 * cselib.c (promote_debug_loc): Don't crash
  on NULL argument. (P221)
- PR target/53759 (sse_loadlps): Use x m x constraints in
  the vmovlps load alternative. (P222)
- mksysinfo.sh: Fix handling of glibc 2.16 bits/resource.h (P223)

* Wed Jul 18 2012 tmb <tmb> 4.7.1-5.mga3
+ Revision: 272346
- rebuild for new glibc

* Wed Jul 18 2012 colin <colin> 4.7.1-4.mga3
+ Revision: 272255
- Exclude a file on x86_64 that will conflict with usrmerge (it will be recreated after install via ldconfig anyway)

* Sat Jul 14 2012 tmb <tmb> 4.7.1-3.mga3
+ Revision: 270744
- rebuild for missing i586 packages

* Tue Jul 10 2012 rtp <rtp> 4.7.1-2.mga3
+ Revision: 269214
- Fix file list on arm.

* Tue Jun 26 2012 tmb <tmb> 4.7.1-1.mga3
+ Revision: 264094
- BR texinfo-tex
- update filelists
- ada/gcc-interface/Makefile.in: fix missing -fPIC flag (P108, upstream)
- rediff P115, P201, P208, P211, P302, P304, P507
- add packages for GNU Transactional Memory library (libitm) support
- update libstdcxx_minor, libgcj_major and libobjc_major
- update to 4.7.1

* Mon Apr 16 2012 blino <blino> 4.6.3-2.mga2
+ Revision: 230992
- add libstdc++ html doc and man pages in new libstdc++-docs package, using Fedora spec bits
  (this also removes prebuilt libstdc++ html doc from gcc-doc)
- pass --disable-quadmath if quadmath is disabled (still not enough to make the rpm build correctly)

* Sat Mar 03 2012 tmb <tmb> 4.6.3-1.mga2
+ Revision: 217194
- drop merged patches: P140, P209
- update to 4.6.3 bugfix release (74 fixes)
- make sure gnative2ascii is in gcj-tools and not in gcc-gnat (#4618)

* Sun Feb 19 2012 tmb <tmb> 4.6.2-2.mga2
+ Revision: 211052
- add fix for PR middle-end/51077 (mga #4593)
  * tree-object-size.c (addr_object_size): Check TREE_CODE of
    MEM_REF's operand rather than code of the MEM_REF itself.
    (fixes Internal compiler error when building lesstif, mga #4492)
- fix libjava bootstrap build with glibc-2.15 (upstream PR/50888)
- make gfortran require quadmath-devel if it is built
+ rtp <rtp>
- Fix build on arm:
  * fix building with quadmath disabled by removed extra info page
  * add missing arm-specific header in the gcc-plugins package

* Mon Dec 05 2011 tmb <tmb> 4.6.2-1.mga2
+ Revision: 176905
- update filelists
- add quadmath libraries for GCC __float128 and Fortran REAL*16 support
- spec cleanup
- rediff ada so.ext patch
- drop p105 (obsolete)
- update lib major/minor
- build with '--enable-linker-build-id'
- fix doc
- fix linux32 support (patch by pcpa, from mdv)
- bump requires on ppl to 0.11.2
- rediff P107, P115, P116, P132, P211, P304, P507 to apply cleanly
- drop merged patches P508-P517
- remove obsolete defattr
- drop support for ppc(64), sparc(64)
- update to 4.6.2

* Sun Sep 11 2011 fwang <fwang> 4.5.2-5.mga2
+ Revision: 142272
- rebuild for new libpng

* Wed Apr 20 2011 rtp <rtp> 4.5.2-4.mga1
+ Revision: 89091
- Add missing link in gcc-gnat (#833)
- Add fix for PR/48090
- cross gcc build fixes:
  - fix cross program prefix to be the same as for the other toolchain tools
  - fix when cross building 32 bit target on 64bit

* Tue Mar 29 2011 rtp <rtp> 4.5.2-3.mga1
+ Revision: 78682
- enable back checks
- cross toolchain fixes. Now, it should be possible to try to build cross
  toolchains (brieftly tested with mipsel cross toolchain on arm).
- disable libffi package so as to make sure newer libffi is used (which is
  the case in fact)
- fix monolithic build due to misplacement of gcc-plugin files.
- add noarch for pdf doc rpm.
- arm support (default DT_GNU_HASH, set __ARM_PCS or __ARM_PCS_VFP, fix
  wformat error)
- mips o32/n32/64 support
- backport PR/21803, PR/47166, PR/44768, PR/46865, workaround for PR/48090

* Tue Jan 18 2011 tmb <tmb> 4.5.2-2.mga1
+ Revision: 23432
- obsolete manbo-mandriva-files-gcc-* for a clean upgrade
- drop rpm tags
- drop manbo support
- drop support for old mandriva releases
- rename mandriva to mageia
- fix bugzilla url
- imported package gcc

